// MustClient.cpp : Defines the entry point for the 'mustclient' application






//// #include <Afxwin.h> // For the CCmdTarget class

#include <windows.h>
#include <atlbase.h>
#include <winuser.h>
CComModule _Module;
#include <commctrl.h>
#include <atlcom.h>
#include <atlwin.h>
#include <aygshell.h>
#include <sipapi.h>

#include <initguid.h> 
#include <connmgr.h>
#include <connmgr_proxy.h>



#include "webview.h"
#include "MustClient.h"



// JEK:VOICECLIENT
// TODO: move to .h file
int connectedFlagVOIP = 0;
//int startRecord       = 0;
//int startPlay         = 0;
int terminalState     = TERMINAL_MAP_APPLICATION;


int WINAPI WinMain(	HINSTANCE hInstance,
				   HINSTANCE hPrevInstance,
				   LPTSTR    lpCmdLine,
				   int       nCmdShow)
{ 
	
	
	
	MSG msg;
	HACCEL hAccelTable;
	
	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) {
		return FALSE;
	}
	
	
	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_MUSTCLIENT);
	
	
	
	//  Create threads for the communication with the GUI Server
	// ---------------------------------------------------------
	
	// Create a thread that reads data from the GUI Server (via socket)
	g_hThread = CreateThread(NULL,0,SocketThread,(LPVOID) NULL,CREATE_SUSPENDED,&g_dwThreadId);
	
	
	/*
	// JEK:VOICECLIENT
	// Create threads for voice communication
	// - Record thread
	record_hThread = CreateThread(NULL,
	0,
	&RecordThread,
	NULL,
	NULL,
	&record_dwThreadId);
	// - Play thread
	play_hThread = CreateThread(NULL,
	0,
	&PlayThread,
	NULL,
	NULL,
	&play_dwThreadId);
	*/
	  
	
	
	if (!ReadConfigFile()){
		MessageBox(NULL, L"Failed in reading MConfig.txt file", L"Error", MB_OK);
		exit(0);
	}
	
	
	
	
	capi_obj = new CeDialer(hwndMain); 
	voip_obj = new VoIP(hwndMain);

	voip_obj->setVerbosity(atoi(&verbosed[0]));
	capi_obj->setVerbosity(atoi(&verbosed[0]));
	
	while (::GetMessage(&msg, NULL, 0, 0) == TRUE)
	{
		if(msg.hwnd == NULL) {
			if(hwndEdit) {
				if(msg.lParam != NULL) {
					::SetWindowText(hwndEdit,(PWCHAR)msg.lParam);	
				}
			}
			// Sends data from mapctrl.dll into the WinProc's message loop
			if(msg.lParam != NULL)
				::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_PARSE_DATA,(LPARAM)msg.lParam);
		}
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) {
			::TranslateMessage(&msg);
			::DispatchMessage(&msg);
		}
	}
	
	return (msg.wParam);   
	
}

#ifdef _WIN32_WCE   
/////////////////////////////////////////////////////////////////////////////
// FUNCTION: LowerSip
//
// COMMENT: Lower the keyboard panel
//        
/////////////////////////////////////////////////////////////////////////////

BOOL LowerSip(void)
{
	BOOL fRes = FALSE;
	SIPINFO si;
	memset(&si,0,sizeof(si));
	si.cbSize = sizeof(si);
	if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
		si.fdwFlags &=~SIPF_ON;
		fRes = SHSipInfo(SPI_SETSIPINFO,0,&si,0);
	}
	return fRes;
}
/////////////////////////////////////////////////////////////////////////////
// FUNCTION: RaiseSip
//
// COMMENT: Raise the keyboard panel
//        
/////////////////////////////////////////////////////////////////////////////
BOOL RaiseSip(void)
{
	BOOL fRes = FALSE;
	SIPINFO si;
	memset(&si,0,sizeof(si));
	si.cbSize = sizeof(si);
	if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
		si.fdwFlags |= SIPF_ON;
		fRes = SHSipInfo(SPI_SETSIPINFO,0,&si,0);
	}
	return fRes;
}

#endif
/////////////////////////////////////////////////////////////////////////////
// FUNCTION: SocketThread
//
// COMMENT: Reads commands from a socket. Support command for 1) exit 
//          program, 2) upload a html-file and save it and 3) browse
//          html-files directly.
//   
/////////////////////////////////////////////////////////////////////////////

DWORD WINAPI SocketThread(LPVOID lParam) {
	

	char cBuffer[MAXBUF];
	//Narada
	char   textSizeBuf[255]; //To hold the size of the html-text
	char  *textBuffer; //To hold the html-text
	//
	wchar_t wcBuffer[MAXBUF];
	int nBytesReceived = 0, nBytesWrite = 0, nTextSize = 0;
	wchar_t wcSep[] = {' ','\0'};
	
	do {
		// Read the document header
		memset(cBuffer, 0,sizeof(cBuffer));
		memset(wcBuffer,0,sizeof(wcBuffer));
		
		if (nBytesReceived = g_sClient.ReadLine(cBuffer,MAX_STRING, 6)) {
			mbstowcs(wcBuffer,cBuffer,strlen(cBuffer));
			// Remove spaces from the beginning of the string.		
			RemoveSep(wcBuffer,wcSep);
			// exit program
			if (!wcsnicmp(wcBuffer,L"EXIT",wcslen(L"EXIT"))) {
				g_sClient.Close();				
				ConnMgrReleaseConnection(hConn,0);
				exit(0);
				// Close socket and suspend this thread
			} else if (!wcsnicmp(wcBuffer,L"DISCONNECT",wcslen(L"DISCONNECT"))) {
				PWCHAR pwcNewText = L"Connect";
				MENUITEMINFO mii;
				memset((char *)&mii, 0, sizeof(mii));
				mii.cbSize = sizeof(mii); 
				mii.fMask  = MIIM_DATA | MIIM_TYPE; 
				mii.fType = MFT_STRING;
				mii.dwTypeData = pwcNewText;
				SetMenuItemInfo(hMenu,IDM_HELP_CONNECT, FALSE, &mii);
				g_sClient.Close();
				g_sClient.m_bSocketCreated = false; 
				SuspendThread(g_hThread);
				ConnMgrReleaseConnection(hConn,0);
				exit(0);

				// Exit program
				////Narada ---  Sometimes we need to save a html file on the client. Then the GUI-Server should 
				// send <<HTMLBODY \n no_of_bytes \n the_actual_text>>  
			} else if (!wcsnicmp(wcBuffer,L"HTMLBODY",wcslen(L"HTMLBODY"))) {
				if ((nBytesReceived = g_sClient.ReadLine(textSizeBuf,MAX_STRING, 1)) && (nTextSize = atoi(textSizeBuf))) {
					textBuffer = new char[nTextSize+2];
					//	textBuffer=strcpy(textBuffer, "\nLokalt lagret buss-informasjon");
					//	nBytesReceived = g_sClient.ReadText(textBuffer,nTextSize,1);
					if((nBytesReceived = g_sClient.ReadText(textBuffer,nTextSize,1)) != nTextSize+2) { //2 is the CRLF inserted by println on the sender
						wchar_t err_msg[255];
						swprintf(&err_msg[0], L"cannot read text: ReadText() %d %d\n", nTextSize, nBytesReceived);
						::MessageBox(hwndMain,&err_msg[0],L"WINSOCK CLIENT", MB_OK);
					}  {
						textBuffer[nBytesReceived] = '\0';
						
						nBytesWrite = WriteHtmlDocument(textBuffer);
						delete [] textBuffer;
					} 
				} else {
					::MessageBox(hwndMain,L"Can't read the correct\r\n order of bytes\r\n from socket. ReadLine()",L"WINSOCK CLIENT", MB_OK);
				}
				
				//Narada ------------
				
				// Read a browse command and it's URL address and browse
				// against this address
			} else if(!wcsnicmp(wcBuffer,L"BROWSEFILE",wcslen(L"BROWSEFILE"))) {
				wcscpy(wcBuffer,&wcBuffer[wcslen(L"BROWSEFILE")]);
				// Remove spaces from the beginning of the string.		
				RemoveSep(wcBuffer,wcSep);
				memset(g_pszFileName,0,sizeof(g_pszFileName));
				DWORD dwLength = 0;
				dwLength= wcslen(wcBuffer);
				wchar_t * wcsTemp = NULL;
				
				if(wcsTemp = wcsstr(wcBuffer,L"\n")) {
					dwLength = wcsTemp-wcBuffer;
				}
				
				wcsncpy(g_pszFileName,wcBuffer,dwLength);
				
				
				::SendMessage(hwndMain,WM_COMMAND,IDC_BROWSE_FROM_SERVER,(LPARAM)0);
			}
		} else {
			
			// Go into this if there is no data on the socket
		}
	}
	while(!g_bKillThread);
	
	if (g_sClient.m_hSocket) {
		g_sClient.Close();
		g_sClient.m_bSocketCreated = false;
		ConnMgrReleaseConnection(hConn,0);
		exit(0);
	}
	
	return 0; // The thread exit
}







// JEK:VOICECLIENT
/////////////////////////////////////////////////////////////////////////////
// FUNCTION: RecordThread
//
// TASK:     Thread for the asynchronous record (synchronous to play thread)
//   
/////////////////////////////////////////////////////////////////////////////
/*DWORD WINAPI RecordThread(VOID *lParam) {

  while (1) {		
		while(1) {
		Sleep(10);
		if (startRecord == 1) break;
		}
		wrobj = new WavRec();
		wrobj->RecordWave();
		delete wrobj;
		//// MessageBox(hwndMain,L"Recording finish \n",NULL,MB_OK);	
		startRecord         = 0;				
		}
		return 0;
}*/
/////////////////////////////////////////////////////////////////////////////
// FUNCTION: RecordThread
//
// TASK:     Thread for the asynchronous play (synchronous to record thread)
//   
/////////////////////////////////////////////////////////////////////////////
/*DWORD WINAPI PlayThread(VOID *lParam) {

  while (1) {		
		while(1) {
		Sleep(10);
		if (startPlay == 1) break;
		}
		wpobj = new WavPlay();
		wpobj->PlayWave(L"DUMMY");
		delete wpobj;
		MessageBox(hwndMain,L"Play finish \n",NULL,MB_OK);			
		startPlay         = 0;			
		}
		return 0; 
		}
		*/
		
		
		/*void  CALLBACK WaveInProc(HWAVEIN waveIn, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
		{
		wrobj->WaveInProc(waveIn, uMsg, dwInstance, dwParam1,dwParam2);
		}
		void  CALLBACK WaveOutProc(HWAVEOUT waveOut, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
		{
		wpobj->WaveOutProc(waveOut, uMsg, dwInstance, dwParam1,dwParam2);
		}
		*/
		
		
		
		
		
		
		
		
		/////////////////////////////////////////////////////////////////////////////
		// FUNCTION: ConnectDlgProc
		//
		// COMMENT:Create a dialog box that can be used to set up a socket 
		//	       communication to a server program.  
		//          
		/////////////////////////////////////////////////////////////////////////////
		
		BOOL CALLBACK ConnectDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
		{
			
			HWND hWnd;
			DWORD size = 0;
			
			switch (message)
			{
			case WM_INITDIALOG:
				{
					
					
					
					SHINITDLGINFO shidi;
					hwndConnect = hDlg;  
					shidi.dwMask = SHIDIM_FLAGS;
					shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
					shidi.hDlg = hDlg;
					SHInitDialog(&shidi);
					
					char cText[5000] = {0};
					memset(cText,0,sizeof(cText));
					
					wchar_t wcText[5000] = {0};
					
					wchar_t * pwcFileName = L"\\windows\\start menu\\Servers.txt";
					wchar_t * pwcErrorText = L"Can't find the file Servers.txt \r\n(It should be in the same \r\ndirectory as MustClient.exe\r\n";
					
					
					
					// Read the Servers.txt file
					DWORD dwCreationDispotion = OPEN_ALWAYS; // File creation attribute
					DWORD dwNumBytes = ReadFile(dwCreationDispotion,cText,pwcFileName,pwcErrorText,hDlg);
					
					mbstowcs(wcText,cText,sizeof(cText));
					
					HWND hWndCombo;
					
					
					
					
					
					
					if(dwNumBytes) {
						
						wchar_t * pwcNextLine = NULL, * pwcLineText = NULL;
						
						// Put text into the combo box
						hWndCombo = GetDlgItem(hDlg,IDC_COMBO_SERVER);
						DWORD dwBufOffset = 0;
						
						// Put the server names and port numbers into the combo box
						int i = 0;
						do {
							if(pwcNextLine = wcsstr(&wcText[dwBufOffset],L"\n")) {
								wchar_t wcBuf[1000] = {0};
								DWORD dwLineLength = pwcNextLine - &wcText[dwBufOffset];
								wcsncpy(wcBuf,&wcText[dwBufOffset],dwLineLength -1 );
								::SendMessage(hWndCombo,CB_ADDSTRING,0L,(LPARAM)(LPCTSTR)wcBuf);
								::SetWindowText(hWndCombo,wcBuf);
								::SendMessage(hWndCombo,CB_SETCURSEL,(WPARAM)(int)i,0L);
								dwBufOffset = pwcNextLine - &wcText[0] + wcslen(L"\n");
							}
							i++;
						} while(pwcNextLine);
					}
					
					hWnd = GetDlgItem(hDlg,IDC_EDIT_INFO);
					// Set text on the button
					if (g_sClient.m_hSocket) {
						HWND hWndButton = GetDlgItem(hDlg,IDC_BUTTON_SERVER);
						//::SendMessage(hWndButton,WM_SETTEXT,0,(LPARAM)L"&Disconnect");
						::SetWindowText(hWnd,info[3]); 
					} else				
						::SetWindowText(hWnd,info[0]); // what is the mission of this jek
					
					::SetWindowText(hWndCombo,server[0]);
					::SendMessage(hWndCombo,CB_SETCURSEL,(WPARAM)(int)0,0L);
					
				}
				
				
				return FALSE;
			case WM_COMMAND:
				{
					DWORD dwID = LOWORD(wParam);
					// Close the dialog box
					if (dwID == IDOK) {
						EndDialog(hDlg, LOWORD(wParam));
						return FALSE;
					}
					// Get notifications from the combo box
					if (dwID == IDC_COMBO_SERVER) {
						hWnd = GetDlgItem(hDlg,IDC_COMBO_SERVER);
						if(HIWORD(wParam) == CBN_SELENDOK)  {
							PWCHAR pwcFindSep;
							WCHAR wcComboText[MAX_STRING] = {0};
							WCHAR wcServerName[MAX_STRING] = {0};
							WCHAR wcPortNumber[MAX_STRING] = {0};
							memset(wcComboText,0,sizeof(wcComboText) * sizeof(wchar_t));
							// Get port-number and sever-name from the combo
							// box and put this information into the edit boxes
							DWORD dwSel= ::SendMessage(hWnd,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
							::SendMessage(hWnd,CB_GETLBTEXT,(WPARAM)dwSel,(LPARAM)wcComboText);
							
							// Allow <space> and <tab> as separators.
							wchar_t wcSep[] = {'?',' ','	','\0'};
							
							RemoveSep(wcComboText,wcSep);
							
							for (int i=0;i<(sizeof(wcSep) - 1);i++) {
								if(pwcFindSep = wcschr(wcComboText,wcSep[i])) 
									break; // Match
							}
							
							DWORD dwServerNameLength = pwcFindSep - wcComboText;	
							
							wcsncpy(wcServerName,wcComboText,dwServerNameLength);
							wcscpy(wcPortNumber,&wcComboText[dwServerNameLength]);
							
							RemoveSep(wcPortNumber,wcSep);
							
							
							HWND hWndServerName = GetDlgItem(hDlg,IDC_EDIT_SERVER_NAME);
							HWND hWndPortNumer = GetDlgItem(hDlg,IDC_EDIT_PORT_NUMBER);
							
							::SendMessage(hWndServerName,WM_SETTEXT,0,(LPARAM)(PWCHAR)wcServerName);
							::SendMessage(hWndPortNumer,WM_SETTEXT,0,(LPARAM)(PWCHAR)wcPortNumber);
						}
						return TRUE;
					}
					// Get notifications from the <connect> button
					if (dwID == IDC_BUTTON_SERVER) {
						// Change the menu text
						
						// Try to connect to a socket server
						hWnd = GetDlgItem(hDlg,IDC_BUTTON_SERVER);
						if(HIWORD(wParam) == BN_CLICKED) {
							WCHAR szGetButtonText[MAX_STRING];
							WCHAR szServerName[MAX_STRING], szPortNumber[MAX_STRING];
							DWORD dwBytes = 0;
							CHAR request[] ="MMCLIENT IS STARTED\r\nResponse with BROWSEFILE<filename>\r\nExample:BROWSEFILE http://myurl.nta.no/example.htm\r\n";
							DWORD dwRequestLength = strlen(request);
							HWND hWndInfo = GetDlgItem(hDlg,IDC_EDIT_INFO);
							HWND hWndServerName = GetDlgItem(hDlg,IDC_EDIT_SERVER_NAME);
							HWND hWndPortNumber = GetDlgItem(hDlg,IDC_EDIT_PORT_NUMBER);
							::SendMessage(hWnd,WM_GETTEXT,MAX_STRING,(LPARAM)szGetButtonText);
							
							// Check if this program already is connected to a server. jek comment: what is this ????
							if(!wcsicmp(szGetButtonText,L"Connect")) {
								// Get the port number and the server name from
								// the edit boxes
								::SendMessage(hWndServerName,WM_GETTEXT,MAX_STRING,(LPARAM)szServerName);
								wcstombs(g_strServerName,szServerName,MAX_STRING);
								::SendMessage(hWndPortNumber,WM_GETTEXT,MAX_STRING,(LPARAM)szPortNumber);
								wcstombs(g_strPortNumber,szPortNumber,MAX_STRING);
								
								// Check if there is any text inside the text boxes
								if((strlen(g_strPortNumber)) && (strlen(g_strServerName))) {
									
									
									
									
									// Try to create a socket
									g_sClient.Create();	
									
									
									// jek
									// g_saServer = CBlockingSocket::GetHostByName(g_strServerName,atoi(g_strPortNumber));	
									g_saServer = CBlockingSocket::MUST_GetHostByAddr(g_strServerName, atoi(g_strPortNumber));
									
									// Try to connect to the socket	
									if (g_sClient.Connect(g_saServer) != SOCKET_ERROR) {
										// Try to write a socket start message to the server
										dwBytes = g_sClient.Write(request, dwRequestLength, 4);
										
										if (dwBytes == dwRequestLength) { // Success
											
											ResumeThread(g_hThread);
											g_sClient.m_bSocketCreated = true;
											
											// Change the menu text
											PWCHAR pwcText = L"Disconnect";
											MENUITEMINFO mii;
											memset((char *)&mii, 0, sizeof(mii));
											mii.cbSize     = sizeof(mii); 
											mii.fMask      = MIIM_DATA | MIIM_TYPE; 
											mii.fType      = MFT_STRING;
											mii.dwTypeData = pwcText;
											SetMenuItemInfo(hMenu,IDM_HELP_CONNECT, FALSE, &mii);
											// Close the dialog box
											
											::SendMessage(hDlg,WM_COMMAND,(WPARAM)IDOK,0L);
											
											// Set status to connected
											//// g_sClient.socketStatus = 1; // use g_sClient.m_bSocketCreated instead
											
											
										} 
										else {
											// Can't write to the socket
											g_sClient.Close();
											::SendMessage(hWndInfo ,WM_SETTEXT,0L,(LPARAM)info[1]);
											ConnMgrReleaseConnection(hConn,0);

										}
									} 
									
									
									else {
										
										// struct hostent * gethostbyaddr(onst char *addr, int len, int type )
										
										// Can't connect to the socket
										g_sClient.Close();
										::SendMessage(hWndInfo,WM_SETTEXT,0L,(LPARAM)info[2]);
									}
								}
								else {
									::MessageBox(hWnd,
										L"Write a server name\r\nand a port number\r\ninto the edit boxes,\r\nbefore you push\r\nthe connect button",NULL,MB_OK);
								}
							} else { // <disconnect> button => disconnect the socket 
								// and suspend the socket thread
								SuspendThread(g_hThread); 
								g_sClient.Close();
								ConnMgrReleaseConnection(hConn,0);
								::SendMessage(hDlg,WM_COMMAND,(WPARAM)IDOK,0L);
							}
						}
						return TRUE;
					}
					break;
			}
	}
    return FALSE; 
}


/////////////////////////////////////////////////////////////////////////////
// FUNCTION: RemoveSep
//
// COMMENT: Remove separators from the beginning of a string. 
//
/////////////////////////////////////////////////////////////////////////////
void RemoveSep(wchar_t * pwcText, wchar_t *pwcSep)
{
	DWORD dwSep = wcslen(pwcSep);
	
	for(DWORD i=0 ; i<wcslen(pwcText) ; i++) {
		DWORD dwSucces = 0;
		for(DWORD j=0 ; j<dwSep ; j++) {
			if(pwcText[i] != pwcSep[j])  {
				dwSucces += 1;
			}
		}
		if(dwSucces == dwSep) { 
			wcscpy(&pwcText[0],&pwcText[i]);
			return;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// FUNCTION: WriteFile
//
// COMMENT: Write a text buffer to a file 
//
/////////////////////////////////////////////////////////////////////////////
DWORD WriteFile(char * pBuffer, wchar_t * pwcFileName)
{
	HANDLE hFile;
	DWORD dwBytesWrite;
	wchar_t wcError[MAX_STRING];
	
	if ((hFile = CreateFile(pwcFileName,       
		GENERIC_WRITE | GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,
		NULL)) == INVALID_HANDLE_VALUE) {
		LPVOID lpMsgBuf;
		FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error CreateFile(): %s\r\n",lpMsgBuf);
        MessageBox(hwndMain,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
		return 0;
	}
	if (!WriteFile(hFile,pBuffer,strlen(pBuffer),&dwBytesWrite, NULL)) {
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error WriteFile(): %d\r\n",lpMsgBuf);
        MessageBox(hwndMain,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
		MessageBox(hwndMain,wcError,NULL,MB_OK);
		CloseHandle(hFile);
		return 0;
	}
	
	CloseHandle(hFile);
	
	return dwBytesWrite;
}

/////////////////////////////////////////////////////////////////////////////
// FUNCTION: ReadFile
//
// COMMENT: Read a text file 
//
/////////////////////////////////////////////////////////////////////////////
DWORD ReadFile(DWORD dwCreationDispotion, char * pText, wchar_t * pwcFileName, wchar_t * pwcErrorText, HWND hWnd)
{
	HANDLE hFile;
	DWORD dwBytesRead;
	DWORD dwMaxSize = 10000;
	wchar_t wcError[MAX_STRING] = {0};
	
	if ((hFile = CreateFile(pwcFileName,       
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		dwCreationDispotion,
		FILE_ATTRIBUTE_NORMAL,
		NULL)) == INVALID_HANDLE_VALUE) {
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		wcscpy(wcError,pwcErrorText);
		swprintf(&wcError[wcslen(wcError)],L"System error: %s\r\n",lpMsgBuf);
        MessageBox(hWnd,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
		return 0;
	}
	
	if (!ReadFile(hFile,pText,dwMaxSize,&dwBytesRead, NULL)) {
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			);
		swprintf(wcError,pwcErrorText);
		swprintf(wcError,L"Error WriteFile(): %d\r\n",lpMsgBuf);
        MessageBox(hWnd,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
		MessageBox(hwndMain,wcError,NULL,MB_OK);
		CloseHandle(hFile);
		return 0;
	}
	
	CloseHandle(hFile);
	
	return dwBytesRead;
	
}

/////////////////////////////////////////////////////////////////////////////
// FUNCTION: MyRegisterClass
//
// COMMENT:  Registers the window class.
/////////////////////////////////////////////////////////////////////////////
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;
	
	
	// Register the main window class 
	wc.style         = 0;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = NULL;
	wc.hCursor       = NULL;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = szWindowClass;
	
	
	return RegisterClass(&wc);
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: InitInstance
//
//  COMMENT: Saves instance handle and creates main window
/////////////////////////////////////////////////////////////////////////////
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	hwndMain = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name
	
	g_hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_MUSTCLIENT, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	
	//If it is already running, then focus on the window
	hwndMain = FindWindow(szWindowClass, szTitle);	
	if (hwndMain) 
	{
		SetForegroundWindow ((HWND) (((DWORD)hwndMain) | 0x01));    
		return 0;
	} 
	
	MyRegisterClass(hInstance, szWindowClass);
	
	RECT rc = {0,26,240,320};
	
	hwndMain = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		rc.left, rc.top, rc.right-rc.left, 
		rc.bottom - rc.top, NULL, NULL, hInstance, NULL);
	
	if (!hwndMain) {	
		return FALSE;
	}
	
	ShowWindow(hwndMain, nCmdShow);
	UpdateWindow(hwndMain);
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  COMMENT:  Processes messages for the main window. 
//			  
/////////////////////////////////////////////////////////////////////////////


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	TCHAR szHello[MAX_LOADSTRING];
	
	
	
	// for case ...BTN5
	char cText2[5000] = {0};
	wchar_t w_hostname[64],w_portnumber[16],w_connectbox_msg[128];
	char *Ptr1,*Ptr2,*Ptr3,*Ptr4;
	int nread;
	FILE *f;
	
	
	
	
	
	
	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{	
		case IDM_HELP_ABOUT:
			DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd,(DLGPROC)About);
			break;
			
			
			
			
		case IDM_TUTORIAL:       
			{				
				
				if (terminalState == TERMINAL_MAP_APPLICATION) { 		
					// 	Change toolbar
					terminalState = TERMINAL_MAP_INTRODUCTION;
					// jek: Send the action to section for handle the tool bar
					::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDM_CHANGE_TOOLBAR,NULL);
					::SetWindowText(hwndEdit,(PWCHAR)L"intro");
					::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tintro\t\n");	
					NavigateURL(L"file://\\Windows\\htdocs\\must_intro_1.html");
				}
				
				break;
			}
			
			
			
			
			
			
			
		case IDM_HELP_CONNECT:
			{
				
				
				
				if (terminalState == TERMINAL_MAP_APPLICATION) {
					
					
					
					
					
					PWCHAR pwcText = L"Disconnect";
					MENUITEMINFO mii_get;
					WCHAR buf[100];
					memset((char *)&mii_get, 0, sizeof(mii_get));
					mii_get.cbSize     = sizeof(mii_get); 
					mii_get.fMask      = MIIM_DATA | MIIM_TYPE; 
					mii_get.fType      = MFT_STRING;
					mii_get.dwTypeData = &buf[0];
					mii_get.cch=sizeof(buf);
					GetMenuItemInfo(hMenu, IDM_HELP_CONNECT, FALSE, &mii_get);
					
					if((mii_get.dwTypeData != NULL) && !wcsicmp(mii_get.dwTypeData,pwcText)) {
						if ( (::MessageBox(hWnd,
							L"You are about to Disconnect  from the Multimodal Server.\r\n\r\nNote: This may take some time!",L"DISCONNECT" ,MB_OKCANCEL) ) 
							== IDCANCEL) {	
							break;
						}
						
						// Change the menu text (after disconnect)
						PWCHAR pwcNewText = L"Connect";
						MENUITEMINFO mii;
						memset((char *)&mii, 0, sizeof(mii));
						mii.cbSize = sizeof(mii); 
						mii.fMask  = MIIM_DATA | MIIM_TYPE; 
						mii.fType  = MFT_STRING;
						mii.dwTypeData = pwcNewText;
						SetMenuItemInfo(hMenu,IDM_HELP_CONNECT, FALSE, &mii);
						
						//NDW Close the socket conection as well 
						if (connectedFlagVOIP && strcmp(capi, "1")==0) {
							capi_obj->Stop();
							connectedFlagVOIP = 0;
							
						}

						if (connectedFlagVOIP && strcmp(capi, "0")!=0) {
							voip_obj->Stop();
							connectedFlagVOIP = 0;
							
						}
						
						SuspendThread(g_hThread); 
						g_sClient.Close();
						g_sClient.m_hSocket = NULL;
						g_sClient.m_bSocketCreated = false;
						ConnMgrReleaseConnection(hConn,0);

						
						// jek after disconnect we simply goes back to the connect box
						WCHAR szTemp[256] = {0};
						SendMessage(hCtlWindow, DTM_CLEAR, 0, (LPARAM)(LPTSTR)szTemp);
						NavigateURL(L"file://\\telenr.bmp");
						//NDW	DialogBox(g_hInst, (LPCTSTR)IDD_CONNECT, hWnd, (DLGPROC)ConnectDlgProc);
						
						
						
					} else {
						// Start connect dialog box
						//NDW DialogBox(g_hInst, (LPCTSTR)IDD_CONNECT, hWnd, (DLGPROC)ConnectDlgProc);
						if ( (::MessageBox(hWnd,
							L"You are about to connect to the Multimodal Server.\r\n\r\nNote: This may take some time!",L"     CONNECT" ,MB_OKCANCEL) ) 
							!= IDCANCEL) {	
							DirectConnect(/*hWnd*/); }//NDW
					}
					
				}
				
				
				
			}
			
			break; 
			
			
		case IDM_EXIT_WIN:
			{   
				//NDW Close the socket conection as well 
				if (connectedFlagVOIP && strcmp(capi, "1")==0) {
					capi_obj->Stop();
					connectedFlagVOIP = 0;
					
				}

				if (connectedFlagVOIP && strcmp(capi, "1")!=0) {
					voip_obj->Stop();
					connectedFlagVOIP = 0;
					
				}
				
				if (g_sClient.m_bSocketCreated == TRUE){
					SuspendThread(g_hThread); 
					g_sClient.Close();
					g_sClient.m_hSocket = NULL;
					g_sClient.m_bSocketCreated = FALSE;
					ConnMgrReleaseConnection(hConn,0);

				}
				::DestroyWindow(hwndMain);
				break;
			}
			
			
			
			
			
			
			
			
			
			
			
			
			// Change toolbar
		case IDM_TOOLBAR:
			{
				PWCHAR pwcText = L"MUST toolbar";
				MENUITEMINFO mii_get;
				WCHAR buf[100];
				memset((char *)&mii_get, 0, sizeof(mii_get));
				mii_get.cbSize = sizeof(mii_get); 
				mii_get.fMask  = MIIM_DATA | MIIM_TYPE; 
				mii_get.fType = MFT_STRING;
				mii_get.dwTypeData = &buf[0];
				mii_get.cch=sizeof(buf);
				GetMenuItemInfo(hMenu, IDM_TOOLBAR, FALSE, &mii_get);
				
				if((mii_get.dwTypeData != NULL) && 
					!wcsicmp(mii_get.dwTypeData,pwcText)) { // Create standard toolbar
					
					CommandBar_Destroy(hwndCB);
					// Create the commando bar with bitmap buttons .
					SHMENUBARINFO mbi;
					
					memset (&mbi, 0, sizeof (SHMENUBARINFO));
					mbi.cbSize     = sizeof (SHMENUBARINFO);
					mbi.hwndParent = hWnd;
					mbi.nToolBarId = IDM_MENU;
					mbi.hInstRes   = g_hInst;
					mbi.nBmpId     = 0;
					mbi.cBmpImages = 0;    
					
					if (!SHCreateMenuBar(&mbi)) {
						MessageBox(hWnd, L"SHCreateMenuBar Failed", L"Error", MB_OK);
						break;
					}
					
					hwndCB = mbi.hwndMB;
					DWORD dwError;
					
					if(!CommandBar_AddToolTips(hwndCB, uNumTips_app,szTips_MustToolbar)) { // jek changed from szTips ..
						dwError = GetLastError();
						MessageBox(hWnd, L"Can't create commando", L"Error", MB_OK);
					}
					
					
					// jek: we show the zoom button until we can inspect the html body - look for home map 
					// if((CommandBar_AddBitmap(hwndCB, g_hInst, IDB_BITMAP1, 7, 16, 16)) == -1) {
					if((CommandBar_AddBitmap(hwndCB, g_hInst, IDB_BITMAP_CMDBARTEST, 7, 16, 16)) == -1) {
						dwError = GetLastError();
						MessageBox(hWnd, L"Can't add bitmap to the commando bar", L"Error", MB_OK);
					}
					
					// Add buttons in tbSTDButton to command bar
					if(!(CommandBar_AddButtons(hwndCB, sizeof(tbButton_app)/sizeof(TBBUTTON),tbButton_app))) {
						MessageBox(hWnd, L"Can't create commando bar buttons", L"Error", MB_OK);
					}
					
					SendMessage (hWnd, WM_PAINT,NULL, NULL );
					
					hMenu = (HMENU)SHMenuBar_GetMenu (hwndCB, IDM_MAIN_ITEM1);
					
					// Change the menu text
					PWCHAR pwcNewText = L"STD toolbar";
					MENUITEMINFO mii;
					memset((char *)&mii, 0, sizeof(mii));
					mii.cbSize = sizeof(mii); 
					mii.fMask  = MIIM_DATA | MIIM_TYPE; 
					mii.fType = MFT_STRING;
					mii.dwTypeData = pwcNewText;
					SetMenuItemInfo(hMenu,IDM_TOOLBAR, FALSE, &mii);
					DWORD test=0;
					
				} else {  // Create an application toolbar
					
					CommandBar_Destroy(hwndCB);
					// Create the commando bar with bitmap buttons .
					SHMENUBARINFO mbi;
					
					memset (&mbi, 0, sizeof (SHMENUBARINFO));
					mbi.cbSize     = sizeof (SHMENUBARINFO);
					mbi.hwndParent = hWnd;
					mbi.nToolBarId = IDM_MENU;
					mbi.hInstRes   = g_hInst;
					mbi.nBmpId     = 0;
					mbi.cBmpImages = 0;    
					
					if (!SHCreateMenuBar(&mbi)) {
						MessageBox(hWnd, L"SHCreateMenuBar Failed", L"Error", MB_OK);
						break;
					}
					
					hwndCB = mbi.hwndMB;
					DWORD dwError;
					
					if(!CommandBar_AddToolTips(hwndCB, uNumTips_std,szTips)) { 
						dwError = GetLastError();
						MessageBox(hWnd, L"Can't create commando", L"Error", MB_OK);
					}
					
					
					if((CommandBar_AddBitmap(hwndCB, g_hInst, IDB_BITMAP_CMDBAR ,3, 16, 16)) == -1) {
						dwError = GetLastError();
						MessageBox(hWnd, L"Can't add bitmap to the commando bar", L"Error", MB_OK);
					}
					
					// Add buttons in tbSTDButton to command bar
					if(!(CommandBar_AddButtons(hwndCB, sizeof(tbButton_std)/sizeof(TBBUTTON),tbButton_std))) {
						MessageBox(hWnd, L"Can't create commando bar buttons", L"Error", MB_OK);
					}
					
					SendMessage (hWnd, WM_PAINT,NULL, NULL );
					
					hMenu = (HMENU)SHMenuBar_GetMenu (hwndCB, IDM_MAIN_ITEM1);
					
					PWCHAR pwcText = L"MUST toolbar";
					MENUITEMINFO mii;
					memset((char *)&mii, 0, sizeof(mii));
					mii.cbSize = sizeof(mii); 
					mii.fMask  = MIIM_DATA | MIIM_TYPE; 
					mii.fType = MFT_STRING;
					mii.dwTypeData = pwcText;
					SetMenuItemInfo(hMenu,IDM_TOOLBAR, FALSE, &mii);
					
				}
				break;
					}
					
					
					
					// jek
					// Change the toolbar dependent on the applications dialogue context
					// Note: This should not be hardcoded, but controlled by the Active-X 
					// component, thus the content of the application
				case IDM_CHANGE_TOOLBAR:
					{
						
						
						
						// test: Convert data to wide characters
						/*
						wchar_t wcData[512]; 
						wcscpy(wcData,L"The data is    : "); // for test
						wcscat(wcData,(PWCHAR)lParam);
						MessageBox(hwndMain,wcData,NULL,MB_OK);		
						*/
						
						// jek Change toolbar for home map	
						// NOTE: This will not work if voice command given
						// TODO: - therefore: Need to inspect the html boody, and check
						// if it is the home map that is displayed.
						char sData[MAX_STRING];// Convert data to mult byte (ordinary char)
						wcstombs(sData,(PWCHAR)lParam,200);
						int CURRENT_TOOLBAR_BITMAP;
						CURRENT_TOOLBAR_BITMAP = IDB_BITMAP_CMDBARTEST;		
						/* // disabled
						if (strstr(sData,"button\t") && strstr(sData,"\thome") ) {
						CURRENT_TOOLBAR_BITMAP = IDB_BITMAP1;
						}
						else if (strstr(sData,"POI\t")) {
						CURRENT_TOOLBAR_BITMAP = IDB_BITMAP_CMDBARTEST;
						}
						else {
						break;
						}
						*/
						
						// jek
						if (terminalState == TERMINAL_MAP_INTRODUCTION) {
							CURRENT_TOOLBAR_BITMAP = IDB_BITMAP3;
						}
						
						
						// Get current settings for the curtain-menu
						PWCHAR pwcText = L"Disconnect";
						MENUITEMINFO mii_get;
						WCHAR buf[100];
						memset((char *)&mii_get, 0, sizeof(mii_get));
						mii_get.cbSize     = sizeof(mii_get); 
						mii_get.fMask      = MIIM_DATA | MIIM_TYPE; 
						mii_get.fType      = MFT_STRING;
						mii_get.dwTypeData = &buf[0];
						mii_get.cch=sizeof(buf);
						GetMenuItemInfo(hMenu, IDM_HELP_CONNECT, FALSE, &mii_get);
						
						g_dwDebugChecked  = CheckMenuItem(hMenu, IDM_DEBUG_WIN,  MF_BYCOMMAND | MF_CHECKED);
						g_dwDebugGrayed   = EnableMenuItem(hMenu,IDM_DEBUG_WIN,  MF_BYCOMMAND | MF_ENABLED);
						g_dwBrowseChecked = CheckMenuItem(hMenu, IDM_BROWSE_WIN, MF_BYCOMMAND | MF_CHECKED);
						g_dwBrowseGrayed  = EnableMenuItem(hMenu,IDM_BROWSE_WIN, MF_BYCOMMAND | MF_ENABLED);					
						
						// jek check if socket is connected - m vaere feil maate ???? - ellers, denne coden har ingen effekt
						/*
						WCHAR szGetButtonText[MAX_STRING];
						::SendMessage(hWnd,WM_GETTEXT,MAX_STRING,(LPARAM)szGetButtonText);
						if(!wcsicmp(szGetButtonText,L"Connect")) {
						wcscpy(szGetButtonText,L"Disconnect");
						}
						*/
						// jek - an alternative
						/* 
						if(g_sClient.m_bSocketCreated) {
						wcscpy(szGetButtonText,L"Disconnect");
						}
						*/
						
						
						// Create the commando bar with the new bitmap buttons .
						CommandBar_Destroy(hwndCB);					
						SHMENUBARINFO mbi;
						memset (&mbi, 0, sizeof (SHMENUBARINFO));
						mbi.cbSize     = sizeof (SHMENUBARINFO);
						mbi.hwndParent = hWnd;
						mbi.nToolBarId = IDM_MENU;
						mbi.hInstRes   = g_hInst;
						mbi.nBmpId     = 0;
						mbi.cBmpImages = 0;    
						if (!SHCreateMenuBar(&mbi)) {
							MessageBox(hWnd, L"SHCreateMenuBar Failed", L"Error", MB_OK);
							break;
						}
						hwndCB = mbi.hwndMB;
						
						
						hMenu = (HMENU)SHMenuBar_GetMenu (hwndCB, IDM_MAIN_ITEM1); // jek moved up
						
						
						DWORD dwError;
						if(!CommandBar_AddToolTips(hwndCB, uNumTips_app,szTips_MustToolbar)) { // jek changed from szTips ..
							dwError = GetLastError();
							MessageBox(hWnd, L"Can't create commando", L"Error", MB_OK);
						}
						if((CommandBar_AddBitmap(hwndCB, g_hInst, CURRENT_TOOLBAR_BITMAP, 7, 16, 16)) == -1) {
							dwError = GetLastError();
							MessageBox(hWnd, L"Can't add bitmap to the commando bar", L"Error", MB_OK);
						}
						
						// Narada (patch)
						if (mic_off == TRUE){
							tbButton_app[9].iBitmap=7;
						}
						else{
							tbButton_app[9].iBitmap=6;
						}
                        //Narada Patch ends
						
						// Add buttons in tbSTDButton to command bar
						if(!(CommandBar_AddButtons(hwndCB, sizeof(tbButton_app)/sizeof(TBBUTTON),tbButton_app))) {
							MessageBox(hWnd, L"Can't create commando bar buttons", L"Error", MB_OK);
						}
						
						
						
						// Now, set the previous state of the curtain-menu
						if (g_dwDebugGrayed == MF_GRAYED) 
							EnableMenuItem(hMenu,IDM_DEBUG_WIN,  MF_BYCOMMAND | MF_GRAYED);
						else {
							CheckMenuItem(hMenu, IDM_DEBUG_WIN,  MF_BYCOMMAND | g_dwDebugChecked);
						}
						if (g_dwBrowseGrayed == MF_GRAYED) 
							EnableMenuItem(hMenu,IDM_BROWSE_WIN,  MF_BYCOMMAND | MF_GRAYED);
						else {
							CheckMenuItem(hMenu, IDM_BROWSE_WIN,  MF_BYCOMMAND | g_dwBrowseChecked);
						}	
						
						
						/*
						// jek check if socket is connected - is this check safe ????
						//// WCHAR szGetButtonText[MAX_STRING];
						::SendMessage(hWnd,WM_GETTEXT,MAX_STRING,(LPARAM)szGetButtonText);
						if(wcsicmp(szGetButtonText,L"Connect")) {
						wcscpy(szGetButtonText,L"Disconnect");
						}
						*/
						
						
						// jek 22082002 - new method for checking if socket for GUI is connected/disconnected
						WCHAR szGetButtonText[MAX_STRING];
						if(g_sClient.m_bSocketCreated) {
							wcscpy(szGetButtonText,L"Disconnect");
						}
						else {
							wcscpy(szGetButtonText,L"Connect");
						}
						
						
						MENUITEMINFO mii;
						memset((char *)&mii, 0, sizeof(mii));
						mii.cbSize = sizeof(mii); 
						mii.fMask  = MIIM_DATA | MIIM_TYPE; 
						mii.fType = MFT_STRING;
						mii.dwTypeData = szGetButtonText;
						
						SetMenuItemInfo(hMenu, IDM_HELP_CONNECT, FALSE, &mii);
						
						
						// jek
						// wcscpy(wcData,L"OKOKOK : "); // for test
						// MessageBox(hwndMain,wcData,NULL,MB_OK);		
						
						// paint 
						SendMessage (hWnd, WM_PAINT,NULL, NULL );
						/// hMenu = (HMENU)SHMenuBar_GetMenu (hwndCB, IDM_MAIN_ITEM1); // jek moved up
						DWORD test=0;
						
						
						break;
					}
					
					
					
					
					
					
					
					
					
					
				case IDM_DEBUG_WIN:
					{
						
						
						
						
						// Also need to check the keyboard panel
						SIPINFO si;
						memset(&si,0,sizeof(si));
						si.cbSize=sizeof(si);
						
						RECT rc;
						memcpy(&rc,&axrc,sizeof(rc));
						
						if(g_dwDebugChecked == MF_CHECKED) {
							g_dwDebugChecked = CheckMenuItem(hMenu,IDM_DEBUG_WIN,MF_BYCOMMAND | MF_UNCHECKED);
							g_dwBrowseGrayed = EnableMenuItem(hMenu,IDM_BROWSE_WIN, MF_BYCOMMAND | MF_ENABLED);
							if (g_dwDebugChecked == MF_CHECKED)
								g_dwDebugChecked = MF_UNCHECKED;
							
							// Hide the edit window
							::ShowWindow(hwndEdit,SW_HIDE);
							
							rc.top =  0;
							// rc.left = 0;
							
							
							// Check the keyboard panel
							if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
								// Check if the keyboard is visible
								if(si.fdwFlags & SIPF_ON) {
									rc.bottom = si.rcVisibleDesktop.bottom;
								} 
							}
							
							::MoveWindow(hCtlWindow,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
							
							
							
							// jek don't work
							// hCtlWindow.ShowScrollBar();
							/* 
							SetScrollRange(hCtlWindow, SB_CTL,  10, 10, FALSE);
							SetScrollRange(hCtlWindow, SB_HORZ, 10, 10, FALSE);
							SetScrollRange(hCtlWindow, SB_VERT, 10, 10, FALSE);
							// jek
							SetScrollRange(hwndMain, SB_CTL,  10, 10, );
							SetScrollRange(hwndMain, SB_HORZ, 10, 10, );
							SetScrollRange(hwndMain, SB_VERT, 10, 10, );
							*/
							
							
							
							
							
						} else if (g_dwDebugChecked == MF_UNCHECKED){
							g_dwDebugChecked = CheckMenuItem(hMenu,IDM_DEBUG_WIN,MF_BYCOMMAND | MF_CHECKED);
							if (g_dwDebugChecked == MF_UNCHECKED)
								g_dwDebugChecked = MF_CHECKED;
							g_dwBrowseGrayed = EnableMenuItem(hMenu,IDM_BROWSE_WIN, MF_BYCOMMAND | MF_GRAYED);
							if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
								// Check if the keyboard is visible
								if(si.fdwFlags & SIPF_ON) {
									rc.bottom = si.rcVisibleDesktop.bottom;
								}
							}
							::MoveWindow(hCtlWindow,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
							
							
							
							
							
							
							
							
							// Show the edit window
							::ShowWindow(hwndEdit,SW_SHOW);	
						}
					}
					
					break;
					
					
				case IDM_BROWSE_WIN:
					{
						
						// Also need to check the keyboard panel
						SIPINFO si;
						memset(&si,0,sizeof(si));
						si.cbSize=sizeof(si);
						
						RECT rc;
						memcpy(&rc,&axrc,sizeof(rc));
						
						
						if(g_dwBrowseChecked == MF_CHECKED) {
							g_dwBrowseChecked = CheckMenuItem(hMenu,IDM_BROWSE_WIN,MF_BYCOMMAND |  MF_UNCHECKED);
							if (g_dwBrowseChecked == MF_CHECKED)
								g_dwBrowseChecked = MF_UNCHECKED;
							g_dwDebugGrayed = EnableMenuItem(hMenu,IDM_DEBUG_WIN, MF_BYCOMMAND | MF_ENABLED);
							// Destroy window
							::ShowWindow(hwndBrowse,SW_HIDE);
							::ShowWindow(hwndCombo,SW_HIDE);
							
							rc.top = 0;
							// Check the keyboard panel
							if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
								// Check if the keyboard is visible
								if(si.fdwFlags & SIPF_ON) {
									rc.bottom = si.rcVisibleDesktop.bottom;
								} 
							}
							::MoveWindow(hCtlWindow,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
							
						} else if (g_dwBrowseChecked == MF_UNCHECKED){
							g_dwBrowseChecked = CheckMenuItem(hMenu,IDM_BROWSE_WIN,MF_BYCOMMAND | MF_CHECKED);
							if (g_dwBrowseChecked == MF_UNCHECKED)
								g_dwBrowseChecked = MF_CHECKED;
							g_dwDebugGrayed = EnableMenuItem(hMenu,IDM_DEBUG_WIN, MF_BYCOMMAND | MF_GRAYED);
							
							
							if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
								// Check if the keyboard is visible
								if(si.fdwFlags & SIPF_ON) {
									rc.bottom = si.rcVisibleDesktop.bottom;
								}
							}
							::MoveWindow(hCtlWindow,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
							// Create window
							::ShowWindow(hwndBrowse,SW_SHOW);
							::ShowWindow(hwndCombo,SW_SHOW);
						}
					}
					break;
					
					/*	case IDM_HISTORY:
					
					  FILE *fd_history; 
					  char *hist_fil;// = "history.txt";
					  int buf_len, act_len;
					  char *tmp_char;
					  
						tmp_char = new char[buf_len];
						
						  int  attr_len, val_len;
						  wchar_t * pwcErrorText;// = L"Can't find the file history.txt \r\n(It should be in the root directory)\r\n";
						  
							if ((fd_history=fopen(hist_fil, "r")) == NULL){
							MessageBox(NULL,pwcErrorText, L"Error", MB_OK);
							exit(0);
							};
							
							  act_len= fread(tmp_char, 1, buf_len, fd_history);
							  
								if (act_len < buf_len){
								if (feof(fd_history)){ //EOF, means OK
								history2html(tmp_char, act_len);
								CreateBrowserControl(hWnd);
								NavigateURL(L"file://\\history.html");
								
								  delete tmp_char;
								  }
								  else if (ferror(fd_history)){ //Error
								  MessageBox(NULL, L"Could not read the history file", L"Error", MB_OK);
								  }
								  }
								  else{
								  MessageBox(NULL, L"IDM_HISTORY:Message Too long to Buffer", L"Error", MB_OK);
								  }
								  
					break;	*/
					
				case IDOK:
					SendMessage(hWnd, WM_ACTIVATE, MAKEWPARAM(WA_INACTIVE, 0), (LPARAM)hWnd);
					SendMessage (hWnd, WM_CLOSE, 0, 0);
					break;
					
					
					
					// Write data to the socket
				case IDC_SEND_TO_SOCKET:
					{
						char sData[MAX_STRING];
						wcstombs(sData,(PWCHAR)lParam,200);
						strcat(sData,"\n");  // jek \r removed
						DWORD dwDataLength = strlen(sData);
						
						// jek convert char to wide characters
						wchar_t wcData[512]; // jek show the data that is written to socket
						mbstowcs(wcData,sData,511);  
						//MessageBox(hwndMain,wcData,NULL,MB_OK);
						
						// jek: Send the action to section for handle the tool bar
						::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDM_CHANGE_TOOLBAR,(LPARAM)(PWCHAR)wcData);
						
						
						
						// SOCKET ERROR ON PPC2002: The socket handler 
						// "g_sClient.m_hSocket" is "NULL", when the first
						// document to browse is sent from the socket server.
						// But this doesn't affect the socket method "write".
						if(g_sClient.m_bSocketCreated) {
							DWORD dwBytes = g_sClient.Write(sData, dwDataLength, 4);
							if(dwBytes != dwDataLength) {
								::SendMessage(hwndEdit,EM_REPLACESEL,FALSE,(LPARAM)L"Socket error");	
								//Error?
							}
						}
					}
					break;
					
					
					
				case IDC_START:
					{
						// Browse to the start URL
						::SetWindowText(hwndEdit,(PWCHAR)startURL);
						if(wcsicmp(startURL,L"")) {
							NavigateURL(startURL);
						}
					}
					break;
					
					
				case IDC_BROWSE_STANDARD_FILE:
					{
						//NavigateURL(localURL);
						
					}
					break;
				case IDC_BACK:
					{
						// Browse to the last URL
						
						WCHAR szTemp[256] = {0};
						
						// Rotate the string in the combo box.
						::SendMessage(hwndCombo,CB_GETLBTEXT,0,(LPARAM)(LPCSTR)szTemp);
						::SendMessage(hwndCombo,CB_DELETESTRING,0,0);
						::SendMessage(hwndCombo,CB_ADDSTRING,0,(LPARAM)(LPCSTR)szTemp);
						::SendMessage(hwndCombo,CB_GETLBTEXT,0,(LPARAM)(LPCSTR)szTemp);
						
						::SetWindowText(hwndCombo,(PWCHAR)szTemp);
						
						// Browse
						// #ifdef PPC2002
						// HTML view control
						SendMessage(hCtlWindow, DTM_NAVIGATE, 0, (LPARAM)(LPTSTR)szTemp);
						// #else
						// IBrowser interface
						// pBrowser->Navigate(szTemp, 0, NULL, NULL);
						// #endif
						
					}
					break;
					
					
					
					
					// jek: WARNING: the trailing \n is removed from the button string
					// sent to the socket since an \n is added before the string is sent to the socket !!!
					
				case IDC_TOOLBTN1:
					{
						if (terminalState == TERMINAL_MAP_APPLICATION) {
							::SetWindowText(hwndEdit,(PWCHAR)L"facilities");
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tfacilities\t");
						}
						
						
						if (terminalState == TERMINAL_MAP_INTRODUCTION) {		
							::SetWindowText(hwndEdit,(PWCHAR)L"exitintro");
							terminalState     = TERMINAL_MAP_APPLICATION;
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\texitintro\t");	
							NavigateURL(L"file://\\Windows\\htdocs\\blanc.html");
							// WCHAR szTemp[256] = {0};
							// SendMessage(hCtlWindow, DTM_CLEAR, 0, (LPARAM)(LPTSTR)szTemp);
							// SendMessage(hCtlWindow, DTM_CLEAR, 0, 0);
						}
						
						
						
						// if (terminalState == TERMINAL_MAP_INTRODUCTION) {		
						// 	::SetWindowText(hwndEdit,(PWCHAR)L"previous");
						//	::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tprevious\t");
						// }
						
						
					}
					break;
				case IDC_TOOLBTN2:
					{
						if (terminalState == TERMINAL_MAP_APPLICATION) {		    
							::SetWindowText(hwndEdit,(PWCHAR)L"stop");
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tstop\t");
						}	
						
						
						// if (terminalState == TERMINAL_MAP_INTRODUCTION) {		
						// 	::SetWindowText(hwndEdit,(PWCHAR)L"previous");
						// 	::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tprevious\t");
						// }
						
						
						
					}
					break;
				case IDC_TOOLBTN3:
					{
						if (terminalState == TERMINAL_MAP_APPLICATION) {
							::SetWindowText(hwndEdit,(PWCHAR)L"info");
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tinfo\t");
						}
						
						
					}
					break;
					
					
					
				case IDC_TOOLBTN4:
					{
						if (terminalState == TERMINAL_MAP_APPLICATION) {
							::SetWindowText(hwndEdit,(PWCHAR)L"zoom_out");
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tzoom_out\t");
						}
						
						
						
					}
					break;
					
					
				case IDC_TOOLBTN5:
					{
						if (terminalState == TERMINAL_MAP_APPLICATION) {
							::SetWindowText(hwndEdit,(PWCHAR)L"home");
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\thome\t");
						}
						
						
						
					}
					break;
					
					
					
					
					
					
					
					
					
				case IDC_TOOLBTN8:  //Earlier this was IDC_TOOLBTN5, I changed this to disable it
					{ 
						
						
						// jek 20102002
						
						memset(cText2,0,sizeof(cText2));
						wchar_t * pwcFileName = L"\\windows\\start menu\\Servers.txt";
						wchar_t * pwcErrorText = L"Can't find the file Servers.txt \r\n(It should be in the same \r\ndirectory as MustClient.exe\r\n";
						
						
						// Read the Servers.txt file
						// DWORD dwCreationDispotion = OPEN_ALWAYS; // File creation attribute
						// DWORD dwNumBytes = ReadFile(dwCreationDispotion,cText,pwcFileName,pwcErrorText,hWnd);
						
						
						
						if ( !(f = fopen("\\windows\\start menu\\Servers.txt","r")) ) {
							::MessageBox(hWnd,pwcErrorText,L"Error",MB_OK);
							exit(0);
						}
						
						
						
						nread = fread(cText2, 1, 5000-1,f);
						if (nread < 5) {
							::MessageBox(hWnd,L"No hostname in the file server.txt",L"Error",MB_OK);
							break;
						}
						fclose(f);
						cText2[nread] = '\0';
						
						
						
						
						// wchar_t t_tmp[500];
						// mbstowcs(t_tmp,cText2,strlen(cText2));
						// swprintf(w_connectbox_msg,L"Content in file:\r\n%s\r\n",t_tmp);
						// ::MessageBox(hWnd,w_connectbox_msg,L"Error",MB_OK);
						
						
						// if (cText2[13] == ' ') {
						// ::MessageBox(hWnd,L"Is SPACE !!!\r\n",L"Error",MB_OK);
						//}
						
						
						
						
						
						// Get hostname and portnumber
						Ptr1 = &cText2[0];
						Ptr2 = strstr(cText2," ");
						Ptr3 = Ptr2 + 1;
						//while(*Ptr3 == ' ') {Ptr3++;}
						// Ptr4 = strstr(Ptr3,"\n");
						Ptr4 = Ptr3 + 4;
						*Ptr2 = 0;
						*Ptr4 = 0;
						WORD dwBytes = 0;
						CHAR request[] ="MMCLIENT IS STARTED\r\nResponse with BROWSEFILE<filename>\r\nExample:BROWSEFILE http://myurl.nta.no/example.htm\r\n";
						DWORD dwRequestLength = strlen(request);
						// DWORD t1,t2;
						// t1 = strlen(Ptr1);
						// t2 = strlen(Ptr3);
						
						if(!g_sClient.m_bSocketCreated) {		
							
							
							mbstowcs(w_hostname,  (const char *)Ptr1,(size_t)strlen(Ptr1));
							mbstowcs(w_portnumber,(const char *)Ptr3,(size_t)strlen(Ptr3));
							swprintf(w_connectbox_msg,L"Connect to GUI Server:\r\n|%s| |%s|\r\n",
								w_hostname,w_portnumber);
							
							
							
							if ( (::MessageBox(hWnd,w_connectbox_msg,
								L"Connect to GUI Server" ,
								MB_OKCANCEL)) == IDCANCEL) {
								break;
							}
							
							
							// Try to create a socket
							g_sClient.Create();	
							
							
							// jek
							// g_saServer = CBlockingSocket::GetHostByName(g_strServerName,atoi(g_strPortNumber));	
							// aServer = CBlockingSocket::MUST_GetHostByAddr("169.254.254.0", atoi("5555"));
							g_saServer = CBlockingSocket::MUST_GetHostByAddr(Ptr1, atoi(Ptr3));
							
							// Try to connect to the socket	
							if (g_sClient.Connect(g_saServer) != SOCKET_ERROR) {
								// Try to write a socket start message to the server
								dwBytes = g_sClient.Write(request, dwRequestLength, 4);
								
								if (dwBytes == dwRequestLength) { // Success
									
									ResumeThread(g_hThread);
									g_sClient.m_bSocketCreated = TRUE;
									
									
									// Change the menu text
									PWCHAR pwcText = L"Disconnect";
									MENUITEMINFO mii;
									memset((char *)&mii, 0, sizeof(mii));
									mii.cbSize     = sizeof(mii); 
									mii.fMask      = MIIM_DATA | MIIM_TYPE; 
									mii.fType      = MFT_STRING;
									mii.dwTypeData = pwcText;
									SetMenuItemInfo(hMenu,IDM_HELP_CONNECT, FALSE, &mii);
									// Close the dialog box
									////::SendMessage(hDlg,WM_COMMAND,(WPARAM)IDOK,0L);
									// Set status to connected
									// g_sClient.socketStatus = 1; // use g_sClient.m_bSocketCreated instead
									
									
								} 
								else {
									// Can't write to the socket
									g_sClient.Close();
									ConnMgrReleaseConnection(hConn,0);
									// ::SendMessage(hWndInfo ,WM_SETTEXT,0L,(LPARAM)info[1]);
									::MessageBox(hWnd,L"Error writing to GUI Client",NULL,MB_OK);
								}
							} 
							
							
							else {
								
								// struct hostent * gethostbyaddr(onst char *addr, int len, int type )
								
								// Can't connect to the socket
								g_sClient.Close();
								::MessageBox(hWnd,L"Error connect to GUI Server",NULL,MB_OK);
								// ::SendMessage(hWndInfo,WM_SETTEXT,0L,(LPARAM)info[2]);
							}
						}
						
						
						
						
						
						
						
						
						/*
						if (terminalState == TERMINAL_MAP_APPLICATION) {				
						// 	Change toolbar
						terminalState = TERMINAL_MAP_INTRODUCTION;
						// jek: Send the action to section for handle the tool bar
						::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDM_CHANGE_TOOLBAR,NULL);
						::SetWindowText(hwndEdit,(PWCHAR)L"intro");
						::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tintro\t\n");					
						
						  }
						*/
						
						
						//// ::SetWindowText(hwndEdit,(PWCHAR)L"");
						//// ::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\t\t\n");
						
						
						// Test CHttpFile 
						/*
						CHttpFile *file = NULL;
						TRY
						{
						CInternetSession *session = NULL;
						session = new CInternetSession();
						CHttpConnection *connection = NULL;
						
						  // To do: specify actual server, port, login name and password here
						  connection = session->GetHttpConnection( L"169.254.254.0/webmust");
						  file = connection->OpenRequest(NULL, L"test.html");
						  // CString strRequestHeader = "Authorization: Basic "; 
						  // strRequestHeader += EncodeBase64(login + _T(":") + L"");
						  // file->AddRequestHeaders(strRequestHeader);
						  // file->SendRequest();
						  char ch;
						  int i = 0;
						  while (file->Read(&ch, 1))
						  {
						  i++;
						  // To do: store file content somewhere:
						  } 
						  delete session;
						  wchar_t tTmp[256];
						  swprintf(tTmp,L"HTTP OK, i = %d",i);
						  MessageBox(hwndMain,tTmp,NULL,MB_OK);	
						  }
						  CATCH(CInternetException, pEx)
						  {
						  MessageBox(hwndMain,L"HTTP error\n",NULL,MB_OK);	
						  }
						  END_CATCH
						  
							*/
							
							
		}
		break;
		
		
		
		
	case IDC_TOOLBTN6:
		
		if (terminalState == TERMINAL_MAP_APPLICATION) {		    
			::SetWindowText(hwndEdit,(PWCHAR)L"lastbus");
			if (g_sClient.m_bSocketCreated && connectedFlagVOIP ==1){ //If connected send the last bus info from server
				::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tlastbus\t");
			}
			else{ //Try to navigate the local file
				::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_BROWSE_STANDARD_FILE,(LPARAM)0);
			}
		}			
		
		break;
		
		
	case IDC_MIC_ON:
		if (mic_off == FALSE){ //mic is on, therefore off it.
			mic_off=TRUE;
			//voip mic off is here
			if (connectedFlagVOIP == 1 && strcmp(capi, "1")==0)
				capi_obj->set_micOff();

			if (connectedFlagVOIP == 1 && strcmp(capi, "1")!=0)
				voip_obj->set_micOff();
			
			//change the icon
			TBBUTTONINFO nfo; 
			nfo.cbSize = sizeof(nfo); 
			nfo.dwMask = TBIF_IMAGE ; 
			nfo.iImage = 7; /* new image index */ 
			::SendMessage(hwndCB, TB_SETBUTTONINFO, IDC_MIC_ON /* id of the button */, (LPARAM)&nfo); 
			
		}
		
        else { //microphone is off, then on it
			mic_off=false;
            //voip_mic on is here
			if (connectedFlagVOIP == 1 && strcmp(capi, "1")==0)
				capi_obj->set_micOn();

			if (connectedFlagVOIP == 1 && strcmp(capi, "1")!=0)
				voip_obj->set_micOn();

			//change the icon
			TBBUTTONINFO nfo; 
			nfo.cbSize = sizeof(nfo); 
			nfo.dwMask = TBIF_IMAGE ; 
			nfo.iImage = 6; /* new image index */ 
			::SendMessage(hwndCB, TB_SETBUTTONINFO, IDC_MIC_ON /* id of the button */, (LPARAM)&nfo); 
			
			
		}
		
		break;
		
#ifdef _TWO_STEP_CONNECTION_ 		//This case can bu deleted
		
	case IDC_TOOLBTN6: 
		{
			
			// JEK:VOICESERVER
			// ---------------
			
			
			if (terminalState == TERMINAL_MAP_APPLICATION) {
				
				
				
				
				// jek: 22082002 - todo: Now, it is forbidden to call out
				// if there is no GUI connection
				/*
				if(!g_sClient.m_bSocketCreated) {
					::MessageBox(hWnd,
						L"Establish a 'VOIP phone' connection.\r\n\r\nYou need to establish a GUI connection (menu/connect) before you can make a phone connection.",NULL,MB_OK);
					break;
				}
				*/
				
				
				
				
				
				
				if (!connectedFlagVOIP) {
					
					if ( (::MessageBox(hWnd,
						L"You are about to make a 'VOIP phone' connection.\r\n\r\nNote: This may take some time!",L"Call out" ,MB_OKCANCEL) ) 
						!= IDCANCEL) {									
						
						// Start hour glass - need #include <Afxwin.h> , gives link error lnk2005
						// CCmdTarget wait;
						// wait.BeginWaitCursor(); 
						
						
						// Connect to the voice (VOIP) server
						//if (voip_obj->Start(/*g_strServerName*/(LPTSTR) 97045786,7777)){
						//if (voip_obj->Start(g_strServerName,7777)){
							connectedFlagVOIP = 1;
						}
						else{
							MessageBox(hwndMain,L"Error connecting to VOIP server",NULL,MB_OK);
                            break;
						}
						/*
						g_sClient_VOIP.Create(); // Try to create a socket	
						// g_saServer = CBlockingSocket::GetHostByName(g_strServerName,atoi(g_strPortNumber));	
						//g_saClient_VOIP = CBlockingSocket::MUST_GetHostByAddr("169.254.254.2", atoi("7777"));
						g_saClient_VOIP = CBlockingSocket::MUST_GetHostByAddr(g_strServerName, atoi("7777"));
						// Try to connect to the socket	
						if (g_sClient_VOIP.Connect(g_saClient_VOIP) != SOCKET_ERROR) {				
						startRecord       = 1;
						startPlay         = 1;
						connectedFlagVOIP = 1;
						g_sClient_VOIP.m_bSocketCreated = true;
						} 
						else {
						MessageBox(hwndMain,L"Error connecting to VOIP server",NULL,MB_OK);	
						g_sClient_VOIP.Close();
						//// ::SendMessage(hwndMain,WM_SETTEXT,0L,(LPARAM)info[2]);
						break;
						
						  
					} */
					}
				}
				
				
				
				
				
				
				
				/*
				::SetWindowText(hwndEdit,(PWCHAR)L"call");
				::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\tcall\t\n");
				*/
				/* ORIGINEL CODE */
				/*
				// jek Dirty way to check if socket connection 
				PWCHAR pwcText = L"Disconnect";
				MENUITEMINFO mii_get;
				WCHAR buf[100];
				memset((char *)&mii_get, 0, sizeof(mii_get));
				mii_get.cbSize     = sizeof(mii_get); 
				mii_get.fMask      = MIIM_DATA | MIIM_TYPE; 
				mii_get.fType      = MFT_STRING;
				mii_get.dwTypeData = &buf[0];
				mii_get.cch=sizeof(buf);
				GetMenuItemInfo(hMenu, IDM_HELP_CONNECT, FALSE, &mii_get);
				
				  if((mii_get.dwTypeData != NULL) && wcsicmp(mii_get.dwTypeData,pwcText)) {
				  // Start connect dialog box
				  DialogBox(g_hInst, (LPCTSTR)IDD_CONNECT, hWnd, (DLGPROC)ConnectDlgProc);
				  }
				*/
				
				
				
			}	
			
		}
		break;
		
#endif		
		
	case IDC_TOOLBTN7:
		{
			
			if (connectedFlagVOIP) {
				
				// wait for thread to be vacant (no threads writes/read the socket)
				/*NDW	while (g_sClient_VOIP.m_bSocketBusyWrite) {
				Sleep(100);
				}
				g_sClient_VOIP.Close();
				g_sClient_VOIP.m_hSocket = NULL;
				g_sClient_VOIP.m_bSocketCreated = false;
				*/
				
				if(strcmp(capi, "1")==0){
				capi_obj->Stop();
				connectedFlagVOIP = 0;
				}

				if(strcmp(capi, "1")!=0){
				voip_obj->Stop();
				connectedFlagVOIP = 0;
				}
			}
			
			
			
			
			
			// ::SetWindowText(hwndEdit,(PWCHAR)L"exit");
			// ::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\texit\t\n");
			
			
			
			
			
			
			
			/*			
			// jek check if socket is connected - is this check safe ????
			WCHAR szGetButtonText[MAX_STRING];
			::SendMessage(hWnd,WM_GETTEXT,MAX_STRING,(LPARAM)szGetButtonText);
			if(wcsicmp(szGetButtonText,L"Connect")) {
			wcscpy(szGetButtonText,L"Disconnect");
			break;	
			}
			*/
			
			
			/*
			// jek Dirty way to check if socket connection 
			PWCHAR pwcText = L"Disconnect";
			MENUITEMINFO mii_get;
			WCHAR buf[100];
			memset((char *)&mii_get, 0, sizeof(mii_get));
			mii_get.cbSize     = sizeof(mii_get); 
			mii_get.fMask      = MIIM_DATA | MIIM_TYPE; 
			mii_get.fType      = MFT_STRING;
			mii_get.dwTypeData = &buf[0];
			mii_get.cch=sizeof(buf);
			GetMenuItemInfo(hMenu, IDM_HELP_CONNECT, FALSE, &mii_get);
			if((mii_get.dwTypeData != NULL) && !wcsicmp(mii_get.dwTypeData,pwcText)) {
			
			  int answer;
			  answer = ::MessageBox(hWnd, L"Would you like to\r\tterminate the call?",NULL, MB_YESNO);
			  if (answer == IDYES) {
			  
				// ::SetWindowText(hwndEdit,(PWCHAR)L"exit");
				// ::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"button\texit\t\n");
				
				  // jek Perform hang-up  - this code is taken from: case: IDC_HELP_CONNECT
				  PWCHAR pwcNewText = L"Connect";
				  MENUITEMINFO mii;
				  memset((char *)&mii, 0, sizeof(mii));
				  mii.cbSize = sizeof(mii); 
				  mii.fMask  = MIIM_DATA | MIIM_TYPE; 
				  mii.fType  = MFT_STRING;
				  mii.dwTypeData = pwcNewText;
				  SetMenuItemInfo(hMenu,IDM_HELP_CONNECT, FALSE, &mii);
				  
					SuspendThread(g_hThread); 
					g_sClient.Close();
					g_sClient.m_hSocket = NULL;
					g_sClient.m_bSocketCreated = false;
					
					  // jek after disconnect we simply goes back to the connect box
					  WCHAR szTemp[256] = {0};
					  SendMessage(hCtlWindow, DTM_CLEAR, 0, (LPARAM)(LPTSTR)szTemp);
					  DialogBox(g_hInst, (LPCTSTR)IDD_CONNECT, hWnd, (DLGPROC)ConnectDlgProc);
					  
						}
						
						  }
						  
			*/
			
			
			
		}
		break;
		
		
		
		// Parse the data from the ActiveX control
				case IDC_PARSE_DATA:
					{
						// Raise the keyboard
						if(!_wcsnicmp((PWCHAR)lParam,L"RAISEKEYBOARD",wcslen(L"RAISEKEYBOARD"))) {
							RaiseSip();
							// Lower the keyboard
						}else if (!_wcsnicmp((PWCHAR)lParam,L"LOWERKEYBOARD",wcslen(L"LOWERKEYBOARD"))) {
							LowerSip();
							// Send map events to the server
						} else {
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)lParam);
						}
					}
					break;
				case IDC_COMBO:
					{
						DWORD dwSel,dwError;
						WCHAR szItem[256];
						if(HIWORD(wParam) == CBN_SELENDOK) {
							dwSel= ::SendMessage(hwndCombo,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
							dwError = ::SendMessage(hwndCombo,CB_GETLBTEXT,(WPARAM)dwSel,(LPARAM)szItem);
							if(dwError != CB_ERR) {
								::SendMessage(hwndCombo,WM_SETTEXT,(WPARAM)0,(LPARAM)(LPCTSTR)szItem); 
							}
						}
					}
					break;
				case IDC_BROWSE:
					{
						
						WCHAR szItem[256]; 
						::SendMessage(hwndCombo,WM_GETTEXT,(WPARAM)100,(LPARAM)szItem); 
						
						//WCHAR texT[256];
						
						// debug code
						// char tmp[256];
						// wcstombs(tmp,szItem,256);
						// wsprintf(texT,L"OK browse, url = %s\n",szItem);
						// MessageBox(hWnd, texT, NULL, MB_OK);			
						
						NavigateURL(szItem);
					}
					break;
					break;
				case IDC_BROWSE_FROM_SERVER:
					{
						NavigateURL(g_pszFileName);
					}
					break;
				case IDC_QUESTION:
					break;
				case IDC_EXIT:
					
					break;
				default:
					break;
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
			
			
			
			
		case WM_CREATE:
			{
				
				// Read saved URL's from a file
				::CoInitializeEx(NULL, COINIT_MULTITHREADED);
				AtlAxWinInit();
				// Create the commando bar with bitmap buttons .
				SHMENUBARINFO mbi;
				
				memset (&mbi, 0, sizeof (SHMENUBARINFO));
				mbi.cbSize     = sizeof (SHMENUBARINFO);
				mbi.hwndParent = hWnd;
				mbi.nToolBarId = IDM_MENU;
				mbi.hInstRes   = g_hInst;
				mbi.nBmpId     = 0;
				mbi.cBmpImages = 0;    
				
				if (!SHCreateMenuBar(&mbi)) {
					MessageBox(hWnd, L"SHCreateMenuBar Failed", L"Error", MB_OK);
					break;
				}
				
				hwndCB = mbi.hwndMB;
				DWORD dwError;
				
				if(!CommandBar_AddToolTips(hwndCB, uNumTips_app, szTips_MustToolbar)) {
					dwError = GetLastError();
					MessageBox(hWnd, L"Can't create commando", L"Error", MB_OK);
				}
				/*if((CommandBar_AddBitmap(hwndCB, g_hInst, IDB_BITMAP_CMDBAR,3, 16, 16)) == -1) {
				dwError = GetLastError();
				MessageBox(hWnd, L"Can't add bitmap to the commando bar", L"Error", MB_OK);
			}*/
				
				
				// jek: we show the zoom button until we can inspect the html body - look for home map 
				//// if((CommandBar_AddBitmap(hwndCB, g_hInst, IDB_BITMAP1,7, 16, 16)) == -1) {
				if((CommandBar_AddBitmap(hwndCB, g_hInst, IDB_BITMAP_CMDBARTEST,7, 16, 16)) == -1) {
					dwError = GetLastError();
					MessageBox(hWnd, L"Can't add bitmap to the commando bar", L"Error", MB_OK);
				}
				
				// Add buttons in tbSTDButton to command bar
				if(!(CommandBar_AddButtons(hwndCB, sizeof(tbButton_app)/sizeof(TBBUTTON),tbButton_app))) {
					MessageBox(hWnd, L"Can't create commando bar buttons", L"Error", MB_OK);
				}
				
				hMenu = (HMENU)SHMenuBar_GetMenu (hwndCB, IDM_MAIN_ITEM1);
				
				// Create an Iexplore Activex control window
				CreateBrowserControl(hWnd);
				NavigateURL(L"file://\\telenr.bmp");
				
				hwndEdit = CreateEditWindow(hWnd);
				
				// Create button controls
				hwndBrowse = CreateBrowseWindow(hWnd);
				// Create a browse combo box
				hwndCombo = CreateComboWindow(hWnd);
				
				memset(g_wcText,0,sizeof(g_wcText));
				memset(g_cText,0,sizeof(g_cText));
				
				// Read the Servers.txt file
				DWORD dwCreationDispotion = OPEN_ALWAYS; // File creation attribute
				
				DWORD dwNumBytes = ReadFile(dwCreationDispotion,g_cText,pwcURLFileName,L"",hWnd);
				
				mbstowcs(g_wcText,g_cText,sizeof(g_cText));
				
				if(dwNumBytes) {
					
					wchar_t * pwcNextLine = NULL, * pwcLineText = NULL;
					
					// Put text into the combo box
					
					DWORD dwBufOffset = 0;
					
					int i = 0;
					do {
						if(pwcNextLine = wcsstr(&g_wcText[dwBufOffset],L"\n")) {
							wchar_t wcBuf[1000] = {0};
							DWORD dwLineLength = pwcNextLine - &g_wcText[dwBufOffset];
							wcsncpy(wcBuf,&g_wcText[dwBufOffset],dwLineLength -1 );
							::SendMessage(hwndCombo,CB_ADDSTRING,0L,(LPARAM)(LPCTSTR)wcBuf);
							::SetWindowText(hwndCombo,wcBuf);
							::SendMessage(hwndCombo,CB_SETCURSEL,(WPARAM)(int)i,0L);
							dwBufOffset = pwcNextLine - &g_wcText[0] + wcslen(L"\n");
						}
						i++;
					} while(pwcNextLine);
				}
				
				
				
				
				// Test the state of the keyboard
				SendMessage(hWnd,WM_SETTINGCHANGE, SPI_SETSIPINFO,0);
				
				wcscpy(lastURL,L"");
				wcscpy(startURL,L"");
				
				bStartURL = TRUE;
				
				
				g_sClient.m_hWnd = hwndEdit;
				// if(hwndBrowse) ::DestroyWindow(hwndBrowse); //jek
				
				
				// jek 
				// Destroy window for browsing
				RECT rc;
				memcpy(&rc,&axrc,sizeof(rc));
				g_dwBrowseChecked = MF_UNCHECKED;	
				::ShowWindow(hwndBrowse,SW_HIDE);
				::ShowWindow(hwndCombo, SW_HIDE);			
				rc.top = 0;
				::MoveWindow(hCtlWindow,rc.left,rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
				
				
				//Background for unconnected application
				//BITMAP bm;
				// change to static_cast if you're using C++
				//
				//HBITMAP 
				//image = (HBITMAP)SHLoadDIBitmap(TEXT("telenr.bmp"));
				//if (image == NULL)
				//	MessageBox(NULL, L"IMage could not load", L"Error", MB_OK);
				//
				//GetObject(image, sizeof(bm), &bm);
				
				
            }
			break;
			
			
		case WM_PAINT:
			RECT rt;
			//---
			//HDC memDC;
			//HBITMAP oldbitmap;
			//---
			
			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rt);
			LoadString(g_hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
			DrawText(hdc, szHello, _tcslen(szHello), &rt, 
				DT_SINGLELINE | DT_VCENTER | DT_CENTER);
			//---
			//memDC=CreateCompatibleDC(hdc);
			//oldbitmap = (HBITMAP)SelectObject(memDC, image);
			//BitBlt(hdc, rt.left, rt.top, bm.bmWidth, bm.bmHeight, memDC, 0, 0, SRCCOPY);
			
			//SelectObject(memDC, oldbitmap);
			//DeleteDC(memDC);
			
			
			EndPaint(hWnd, &ps);
			break; 
			
			
			
		case WM_DESTROY:
			{
				// Can't write to the socket
				if(g_sClient.m_hSocket != NULL)
					g_sClient.Cleanup();
				if(pBrowserEvents)
					pBrowserEvents->Unadvise(
					dwCookie
					);
				
				::CoUninitialize();
				CommandBar_Destroy(hwndCB);
				if(hwndExit) ::DestroyWindow(hwndExit);
				if(hwndBrowse) ::DestroyWindow(hwndBrowse);
				if(hwndEdit) ::DestroyWindow(hwndEdit);
				::DestroyWindow(hwndMain);
				//delete \\Temp\\*.gif;

				PostQuitMessage(0);
				
			}
			break;
		case WM_VSCROLL:
			break;
		case WM_SETTINGCHANGE:
			{
				if(wParam == SPI_SETSIPINFO) {
					
					
					
#ifdef _WIN32_WCE
					// Fill the si variable with information about
					// the input panel.
					SIPINFO si;
					memset(&si,0,sizeof(si));
					si.cbSize = sizeof(si);
					if(SHSipInfo(SPI_GETSIPINFO,0,&si,0)) {
						
						RECT rc;
						memset(&rc,0,sizeof(rc));
						memcpy(&rc,&axrc,sizeof(rc));
						
						// Check if the the edit (debug) or Combo (browse window) are visible
						// If not move the activex control window to the top.
						HWND test = hwndMain;
						if(!IsWindowVisible(hwndCombo) && !IsWindowVisible(hwndEdit) && hwndMain) {
							rc.top = 0;
						}
						
						
						// Check if the keyboard is visible
						if(si.fdwFlags & SIPF_ON) {
							::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)L"Button\tKeyboard\t\n");
							rc.bottom = si.rcVisibleDesktop.bottom;
						} 
						
						MoveWindow(hCtlWindow,rc.left, rc.top,rc.right-rc.left,rc.bottom-rc.top,TRUE);
						
					}
#endif // _WIN32_WCE
				} else {
					SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
				}
			}
			break;

		case WM_USER+12:
#ifdef _MSG_TO_SCREEN_
			MessageBox(NULL, L"Socket Error Message Received", TEXT("Error"), MB_OK);
#endif
			::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDM_HELP_CONNECT,(LPARAM)(PWCHAR)L"button\tfacilities\t");
						
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}





/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: NavigateURL
//
//  COMMENT: Navigate URL and save the URL address 
//           
/////////////////////////////////////////////////////////////////////////////
void NavigateURL(PWCHAR pszURL)
{
    // Add the URL to the combo box if it doesn't exist
	if(CB_ERR == ::SendMessage(hwndCombo,CB_FINDSTRING,0,(LPARAM)(LPCSTR)pszURL)) {
		::SendMessage(hwndCombo,CB_INSERTSTRING,0,(LPARAM)(LPCSTR)pszURL);
	}
	
	DWORD dwCount = ::SendMessage(hwndCombo,CB_GETCOUNT,0,0);
	
	if(dwCount > g_dwMaxURL) {
		for(DWORD i = g_dwMaxURL ; i<dwCount ; i++) {
			::SendMessage(hwndCombo,CB_DELETESTRING,g_dwMaxURL - 1,0);
		}
		dwCount = ::SendMessage(hwndCombo,CB_GETCOUNT,0,0);
	}
	
	// Save the url's inside the combo box to a file
	char cBuf[5000] = {0};
	wchar_t wcTemp[256] = {0}, wcBuf[5000] = {0};
	
	if(dwCount) {
		for(DWORD i = 0; i < dwCount;i++) {
			::SendMessage(hwndCombo,CB_GETLBTEXT,i,(LPARAM)(LPCSTR)wcTemp);
			wcscat(wcBuf,wcTemp);
			wcscat(wcBuf,L"\r\n");
			memset(wcTemp,0,sizeof(wcTemp));
		}
	}
	
	wcstombs(cBuf,wcBuf,sizeof(cBuf));
	
	WriteFile(cBuf,pwcURLFileName);
	
	if(bStartBrowse == FALSE) {
		wcscpy(startURL,pszURL);
		bStartBrowse = TRUE;
	}
	
	// Browse
	//#ifdef PPC2002
	// HTML view control
	SendMessage(hCtlWindow, DTM_NAVIGATE, 0, (LPARAM)(LPTSTR)pszURL);
	//#else
	// IBrowser interface
	//pBrowser->Navigate(pszURL, 0, NULL, NULL);
	//#endif
	
}



/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: CreateBrowserControl
//
//  COMMENT:  Get a pointer to the IBrowser interface for IE. 
// 
/////////////////////////////////////////////////////////////////////////////
BOOL CreateBrowserControl(HWND hwnd)
{
    
    RECT rc;
	BOOL bCreateControl = false;
    
	SetRect(&rc, 0, 120, 240 , 270);
	
	
	
	
	// #ifdef PPC2002  // Pocket PC 2002
	// the only function call required to create a browser control instance
	if(InitHTMLControl(g_hInst)) {
		
		// create the window for the control
		hCtlWindow = CreateWindow(TEXT("DISPLAYCLASS"), NULL, WS_VISIBLE, rc.left, rc.top,rc.right-rc.left,rc.bottom-rc.top, 
			hwnd, NULL, g_hInst, NULL);
		
		SendMessage(hCtlWindow, DTM_ENABLESCRIPTING, 0, TRUE);
		ShowWindow(hCtlWindow, SW_SHOW);
		UpdateWindow(hCtlWindow);
		bCreateControl = true;				
	}
	else
	{
		MessageBox(hwnd, TEXT("Unable to Launch Browser"), TEXT("Browser Control Problem:") , NULL);
		DestroyWindow(hwnd);
	}
	
	
	/*
	//#else // Pocket PC 2000
	HRESULT hr;
	CComPtr<IAxWinHostWindow> spHost;
	
	  paxWindow = new CAxWindow();
	  
		// CLSID_MustClient("8856F961-340A-11D0-A96B-00C04FD705A2")
		
		  paxWindow->Create(hwnd, &rc, 
		  _T("{698E3FCA-70C3-11D0-81E8-00A0C90AD20A}"), (WS_CHILD|WS_VISIBLE|WS_BORDER));
		  
			
			  paxWindow->QueryHost(&spHost);
			  
				hr = paxWindow->QueryControl(
				IID_IBrowser,
				(void**)&pBrowser
				);
				bCreateControl = true;
				
				  hCtlWindow = paxWindow->m_hWnd;
				  
					// #endif // PC2000
	*/
	
	
	return bCreateControl;
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: BrowseDlgProc
//
//  COMMENT:  Message handler for the browse dialog box
/////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK BrowseDlgProc(
							HWND hwndDlg,
							UINT message,
							WPARAM wParam,
							LPARAM lParam
							)
{
    UINT nID;
    UINT nNotify;
    static HWND hwndFileList = NULL;
	static HWND hwndTest = NULL; 
    switch(message)
    {
    case WM_INITDIALOG:
        hwndFileList = ::GetDlgItem(hwndDlg, IDC_FILE_LIST);
        FillFileList(hwndFileList);
        break;
		
    case WM_COMMAND:
        nID = LOWORD(wParam);
        nNotify = HIWORD(wParam);
		
        switch(nID)
        {
        case IDC_FILE_LIST:
            if (nNotify == LBN_SELCHANGE)
            {
				int nSel;
				nSel = (int)::SendMessage(hwndFileList, LB_GETCURSEL, 0, 0);
				::SendMessage(hwndFileList, LB_GETTEXT, (WPARAM)nSel,
					(LPARAM)(LPCTSTR)g_pszFileName);
				hwndTest = ::GetDlgItem(hwndDlg, IDC_EDIT_BROWSE);
				::SetWindowText(hwndTest,g_pszFileName);
            }
            break;
		case IDC_EDIT_BROWSE:
			break;
        case IDOK:            
			wchar_t szBuf[100];
			hwndTest = ::GetDlgItem(hwndDlg, IDC_EDIT_BROWSE);
			GetWindowText(hwndTest,szBuf,100);
			if(wcslen(szBuf) > 1) {
				::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_BROWSE_URL,(LPARAM)(PWCHAR)szBuf);
				//pBrowser->Navigate(szBuf, 0, NULL, NULL);
				NavigateURL(szBuf);
			} else {
				BrowseTo(hwndFileList);
			}
			//Intentional Fall-Thru
			//  |     |      |
			//  V     V      V
        case IDCANCEL:
            ::EndDialog(hwndDlg, nID);
            break;
			
        default:
            break;
        }
    }
    return (FALSE);
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: BrowseTo
//
//  COMMENT:  Use the IBrowser interface to browse files 
/////////////////////////////////////////////////////////////////////////////
void BrowseTo(HWND hwndFileList)
{
    int nSel;
    nSel = (int)::SendMessage(hwndFileList, LB_GETCURSEL, 0, 0);
    ::SendMessage(hwndFileList, LB_GETTEXT, (WPARAM)nSel,
        (LPARAM)(LPCTSTR)g_pszFileName);
	
	NavigateURL(g_pszFileName);
	//pBrowser->Navigate(
	//  g_pszFileName, 0, NULL, NULL);
	//pBrowser->Stop();
}
/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: FillFileList
//
//  COMMENT:  Show html-files in a list box 
/////////////////////////////////////////////////////////////////////////////
void FillFileList(HWND hwndFileList)
{
    WIN32_FIND_DATA fd;
    TCHAR pszFileName[MAX_PATH];
    HANDLE hFind = NULL;
    BOOL bContinue = TRUE;
	
    memset(&fd, 0, sizeof(fd));
	
    hFind = ::FindFirstFile(
        TEXT("\\Program Files\\ActiveX\\mapapp\\*.htm")/* TEXT("\\Windows\\*.html")*/,
        &fd
        );
    if (INVALID_HANDLE_VALUE != hFind)
    {
        while (bContinue)
        {
            wsprintf(pszFileName, TEXT("\\Program Files\\ActiveX\\mapapp\\%s"), fd.cFileName);
            ::SendMessage(hwndFileList, LB_ADDSTRING, 0, (LPARAM)(LPCTSTR)pszFileName);
            bContinue = ::FindNextFile(
                hFind,
                &fd
                );
        }
        ::FindClose(hFind);
    }
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: About
//
//  COMMENT:  Mesage handler for the About box.
/////////////////////////////////////////////////////////////////////////////
/*LRESULT*/BOOL CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		
		SHINITDLGINFO shidi;
		// Create a Done button and size it.
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		shidi.hDlg = hDlg;
		//initialzes the dialog based on the dwFlags parameter
		SHInitDialog(&shidi);
		
	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK) {
			EndDialog(hDlg, /*LOWORD(wParam)*/0);
			return TRUE;
		}
		break;
	}
    return FALSE;
}







HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;
	
	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;
	
	if (!SHCreateMenuBar(&mbi)) 
		return NULL;
	
	return mbi.hwndMB;
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTIONS: CreateExitWindow, CreateBrowseWindow and CreateEditWindow
//
//  COMMENT:  Create button windows.
/////////////////////////////////////////////////////////////////////////////
HWND CreateExitWindow(HWND hwndParent)
{
	DWORD dwStyle = WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON;
	
	return ::CreateWindow(
		TEXT("BUTTON"),
		TEXT("Exit"),
		dwStyle,
		0, 5, 50, 30, 
		hwndParent,
		(HMENU)IDC_EXIT,
		g_hInst,
		NULL
		);
}

HWND CreateBrowseWindow(HWND hwndParent)
{
	DWORD dwStyle = WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON;
	
	return ::CreateWindow(
		TEXT("BUTTON"),
		TEXT("GO"),
		dwStyle,
		205, 5, 30, 30, 
		hwndParent,
		(HMENU)IDC_BROWSE,
		g_hInst,
		NULL
		);
}

HWND CreateEditWindow(HWND hwndParent)
{
	DWORD dwStyle = /*WS_VISIBLE |*/ WS_CHILD | ES_MULTILINE | ES_READONLY | WS_VSCROLL;
	
	return ::CreateWindow(
		TEXT("EDIT"),
		TEXT("Edit"),
		dwStyle,
		5,5,225,30,
		hwndParent,
		(HMENU)IDC_EDIT,
		g_hInst,
		NULL
		);
}

HWND CreateComboWindow(HWND hwndParent)
{	
	DWORD dwStyle = WS_VISIBLE | WS_CHILD | WS_VSCROLL | WS_VSCROLL | CBS_DROPDOWN | CBS_AUTOHSCROLL;
	return ::CreateWindow(
		TEXT("COMBOBOX"),
		TEXT("COMBOBOX"),
		dwStyle,
		3,5,200,100,
		hwndParent,
		(HMENU)IDC_COMBO,
		g_hInst,
		NULL
		);
};





BOOL GUI_Connect(char *server_ip, char *gui_port){
	
	
	// Change the menu text
	
	// Try to connect to a socket server
	//hWnd = GetDlgItem(hDlg,IDC_BUTTON_SERVER);
	
	//WCHAR szGetButtonText[MAX_STRING];
	//WCHAR *szServerName=L"169.254.254.0"; //[MAX_STRING], 
	//WCHAR *szPortNumber=L"5555"; //[MAX_STRING];
	DWORD dwBytes = 0;
	CHAR request[] ="MMCLIENT IS STARTED\r\nResponse with BROWSEFILE<filename>\r\nExample:BROWSEFILE http://myurl.nta.no/example.htm\r\n";
	DWORD dwRequestLength = strlen(request);
	//HWND hWndInfo = GetDlgItem(hDlg,IDC_EDIT_INFO);
	//HWND hWndServerName = GetDlgItem(hDlg,IDC_EDIT_SERVER_NAME);
	//HWND hWndPortNumber = GetDlgItem(hDlg,IDC_EDIT_PORT_NUMBER);
	//::SendMessage(hWnd,WM_GETTEXT,MAX_STRING,(LPARAM)szGetButtonText);
	
	// Check if this program already is connected to a server. jek comment: what is this ????
	//if(!wcsicmp(szGetButtonText,L"Connect")) {
				// Get the port number and the server name from
				// the edit boxes
				//::SendMessage(hWndServerName,WM_GETTEXT,MAX_STRING,(LPARAM)szServerName);
				//wcstombs(g_strServerName,szServerName,MAX_STRING);
				//::SendMessage(hWndPortNumber,WM_GETTEXT,MAX_STRING,(LPARAM)szPortNumber);
				//wcstombs(g_strPortNumber,szPortNumber,MAX_STRING);
	
	strcpy(g_strServerName, &server_ip[0]);
	strcpy(g_strPortNumber, &gui_port[0]);
				
				// Check if there is any text inside the text boxes
				if((strlen(g_strPortNumber)) && (strlen(g_strServerName))) {
					
					
					
					
					// Try to create a socket
					g_sClient.Create();	
					
					
					// jek
					// g_saServer = CBlockingSocket::GetHostByName(g_strServerName,atoi(g_strPortNumber));	
					g_saServer = CBlockingSocket::MUST_GetHostByAddr(g_strServerName, atoi(g_strPortNumber));
					
					// Try to connect to the socket	
					if (g_sClient.Connect(g_saServer) != SOCKET_ERROR) {
						// Try to write a socket start message to the server
						dwBytes = g_sClient.Write(request, dwRequestLength, 4);
						
						if (dwBytes == dwRequestLength) { // Success
							
							ResumeThread(g_hThread);
							g_sClient.m_bSocketCreated = true;
							
							// Change the menu text
							PWCHAR pwcText = L"Disconnect";
							MENUITEMINFO mii;
							memset((char *)&mii, 0, sizeof(mii));
							mii.cbSize     = sizeof(mii); 
							mii.fMask      = MIIM_DATA | MIIM_TYPE; 
							mii.fType      = MFT_STRING;
							mii.dwTypeData = pwcText;
							SetMenuItemInfo(hMenu,IDM_HELP_CONNECT, FALSE, &mii);
							// Close the dialog box
							
							//	::SendMessage(hDlg,WM_COMMAND,(WPARAM)IDOK,0L);
							
							// Set status to connected
							//// g_sClient.socketStatus = 1; // use g_sClient.m_bSocketCreated instead
							
							
						} 
						else {
							// Can't write to the socket
							g_sClient.Close();
							ConnMgrReleaseConnection(hConn,0);
							//	::SendMessage(hWndInfo ,WM_SETTEXT,0L,(LPARAM)info[1]);
							return FALSE;
						}
					} 
					
					
					else {
						
						// struct hostent * gethostbyaddr(onst char *addr, int len, int type )
						
						// Can't connect to the socket
						g_sClient.Close();
						ConnMgrReleaseConnection(hConn,0);
						//		::SendMessage(hWndInfo,WM_SETTEXT,0L,(LPARAM)info[2]);
						return FALSE;
					}
				}
				else {
					::MessageBox(/*hWnd*/NULL,
						L"Write a server name\r\nand a port number\r\ninto the edit boxes,\r\nbefore you push\r\nthe connect button",NULL,MB_OK);
				}
				//			} 
				//else { // <disconnect> button => disconnect the socket 
				// and suspend the socket thread
				//			SuspendThread(g_hThread); 
				//				g_sClient.Close();
				//				::SendMessage(hDlg,WM_COMMAND,(WPARAM)IDOK,0L);
				//			}
				
				return TRUE;
				
				
				
}



BOOL CAPI_Connect(char *phonenr ){
	
	if (terminalState == TERMINAL_MAP_APPLICATION) {
		
		
		
		if (!connectedFlagVOIP) {
			
			

			wchar_t *tlf; 
			tlf = new wchar_t[81];
			
			
			int retur;
			retur=	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, phonenr,81, tlf, 81);
			
			if (retur == 0){
			MessageBox(hwndMain,L"error in mbtowc",NULL,MB_OK);
			exit(0);
			}
			
			
			if (capi_obj->Start((LPCTSTR)tlf))
					{								
						connectedFlagVOIP = 1;
				
							if (mic_off == TRUE) 
								capi_obj->set_micOff();

							else{
								capi_obj->set_micOn();}
					
			
			}
			
					else{
				MessageBox(hwndMain,L"Error connecting to CAPI server",NULL,MB_OK);
				//break;
				return FALSE;
						}
			
			}	
	}

	return TRUE;
}

	




BOOL VOIP_Connect(char *server_ip, char *voip_port ){
	
	if (terminalState == TERMINAL_MAP_APPLICATION) {
	
	
				if (voip_obj->Start(server_ip, atoi(&voip_port[0] )))
				{
					connectedFlagVOIP = 1;

						if (mic_off == TRUE) 
							voip_obj->set_micOff();
				
						else
						{voip_obj->set_micOn();}

				return TRUE;
				}
			
				else{
				MessageBox(hwndMain,L"Error connecting to VOIP server",NULL,MB_OK);
				//break;
				return FALSE;
				}
			
	}
		
return TRUE;
}
	




DWORD GPRS()

{

			

			
			DWORD t;			
			CONNMGR_CONNECTIONINFO ci = { 0 };
            ci.cbSize           = sizeof(ci);
            ci.dwParams         = CONNMGR_PARAM_GUIDDESTNET;  // | CONNMGR_PARAM_MAXCONNLATENCY;
			ci.dwPriority = CONNMGR_PRIORITY_USERINTERACTIVE; 
            ci.dwFlags          = 0; 
			ci.bExclusive = false; 
			ci.bDisabled = false; 
            ci.guidDestNet      = IID_DestNetInternet;  //GetNetworkGuid();
			ci.hWnd = 0;
			ci.uMsg = 0;
			ci.lParam = 0;

			ConnMgrEstablishConnectionSync(&ci, &hConn, 20000, &t);
		
			int nTries = 0;

			do{
				Sleep(500);
				nTries ++;

			}while((t==CONNMGR_STATUS_WAITINGCONNECTION || t==CONNMGR_STATUS_UNKNOWN) && nTries<20); 
				
			  


	return t;

}

BOOL DirectConnect(){
	


	
		//if (! ReadConfigFile(&serverIP[0], &guiPort[0], &voipPort[0]))
	if (strcmp(serverIP,"") ==0  || strcmp(guiPort,"") == 0 || strcmp(voipPort,"")== 0){
		

		MessageBox(NULL, L"Cannot Connect to the server because server name and port numbers are not available", L"Error",MB_OK);
			//MessageBox(NULL, TEXT(serverIP), L"TS",MB_OK);

		return FALSE;
	}

	if(strcmp(capi, "1")==0){

		capi_obj = new CeDialer(hwndMain); 
	
	DWORD status;
	status = GPRS();

	
	if(status==CONNMGR_STATUS_CONNECTED) 
	{
		if (CAPI_Connect(&phonenr[0]))
		{
					if (GUI_Connect(&serverIP[0], &guiPort[0]))
					{
										
					return TRUE;
					}
									
		}
	}
		
	}


	
	
		if(strcmp(capi, "1")!=0)
			{
				voip_obj = new VoIP(hwndMain);

				if (VOIP_Connect(&serverIP[0], &voipPort[0]))
				{
					if (GUI_Connect(&serverIP[0], &guiPort[0]))
					{
					return TRUE;
					}
				}
			}

	
	return FALSE;
				
}




/******************

  BOOL ReadConfigFile(char *server_ip, char *gui_port, char *voip_port) {
  
	//Read the server information from a file
	char cText[5000] = {0};
	//char *ip, *gui_port, *voip_port;
	memset(cText,0,sizeof(cText));
	wchar_t * pwcFileName = L"Server.txt";
	wchar_t * pwcErrorText = L"Can't find the file Servers.txt \r\n(It should be in the root directory)\r\n";
				
				  // Read the Servers.txt file
				  DWORD dwCreationDispotion = OPEN_ALWAYS; // File creation attribute
				  DWORD dwNumBytes = ReadFile(dwCreationDispotion,cText,pwcFileName,pwcErrorText,NULL);
				  
					int state =0;int st=0; int lst= 0;
					int quan=0;
					
					  for (int i=0;i<dwNumBytes;i++){
					  if (quan > 2)
					  break;
					  switch (state){
					  
						case 0:
						if (cText[i] != ' ' && cText[i] != '\t'){
						st=i;
						state=1;
						break;
						}
						else
						break;
						
						  case 1:
						  if (cText[i] == ' ' || cText[i] == '\t'){
						  lst=i;
						  state=0;
						  if (quan ==0)
						  strncpy(server_ip, &cText[st], lst-st+1);
						  else if (quan ==1)
						  strncpy(gui_port, &cText[st], lst-st+1);
						  else if (quan ==2)
						  strncpy(voip_port, &cText[st], lst-st+1);
						  
							quan++; 
							break;
							}
							else
							break;
							}
							}
							
							  if (quan == 3)
							  return TRUE;
							  else if (quan== 2 && state==1 ){
							  strncpy(voip_port, &cText[st],dwNumBytes-st+1);
							  return TRUE;
							  }
							  else{
							  MessageBox(NULL, L"Server.txt has a wrong format" ,L"Error", MB_OK);
							  exit(0);
							  }
							  
								
								  
									}
************************/
//-----------------------------------------
// Reads the client configuration parameters from the
// config file
// Currently read parameters are 
// serverIP
// guiPort
// voipPort
// verbosed 
// The format of the parameter file would be  
//              SERVER_IP  148.245.245.2
//              GUI_PORT    5555
//              VOIP_PORT   7777
//              VERBOSED    1   
//------------------------------------------  
BOOL ReadConfigFile() {
	
    FILE *fd_cfg; 
	char *cfg_fil = "\\Program Files\\MustClient\\MConfig.txt";
	char tmp_char[100];
	char attr[100], val[100];
	//int  attr_len, val_len;
	wchar_t * pwcErrorText = L"Can't find the file MConfig.txt \r\n(It should be in the root directory)\r\n";
				
	if ((fd_cfg=fopen(cfg_fil, "r")) == NULL){
		MessageBox(NULL,pwcErrorText, L"Error", MB_OK);
		exit(0);
	};
	
	//char tekst[100] = "Thormod \n";
	//printf(tekst);
    strcpy(serverIP,"");
	strcpy(guiPort,"");
	strcpy(voipPort,"");
	strcpy(verbosed,"");
	strcpy(phonenr,"");
	strcpy(capi,"");

	
	while (feof(fd_cfg)==0 && ferror(fd_cfg) ==0 ){
		if (fgets(&tmp_char[0],100,fd_cfg) != NULL){
			  //printf("TMP_CHAR = \"%s\"\n",tmp_char);
            //if (strcmp(tmp_char,"")==0 || strcmp(tmp_char,"\n")==0)
			if (IsEmptyString(&tmp_char[0]))
				continue;
			if (BreakString (&tmp_char[0],&attr[0],&val[0])){
				printf("Attr = \"%s\", val = %s\n", &attr[0], &val[0]);
				if (strcmp(&attr[0], "SERVER_IP")==0)
					strcpy(&serverIP[0], &val[0]);
				else if (strcmp(&attr[0], "GUI_PORT")==0)
					strcpy(&guiPort[0], &val[0]);
				else if (strcmp(&attr[0], "VOIP_PORT")==0)
					strcpy(&voipPort[0], &val[0]);
				else if (strcmp(&attr[0], "PHONENR")==0)					
					strcpy(&phonenr[0], &val[0]);
				else if (strcmp(&attr[0], "CAPI")==0)
					strcpy(&capi[0], &val[0]);
				else if (strcmp(&attr[0], "VERBOSED")==0)
					strcpy(&verbosed[0], &val[0]);
				
				else{
					MessageBox(NULL, L"MConfig.txt has a wrong format" ,L"Error", MB_OK);
					exit(0);
				}
				
			}
			else{
				MessageBox(NULL, L"MConfig.txt has a wrong format2" ,L"Error", MB_OK);
				exit(0);
			}
			
		}
	}

	if (fclose(fd_cfg))
    {
        wprintf(L"fclose failed!\n");
    }

	
	if (strcmp(serverIP, "")== 0 || strcmp(guiPort,"")==0 || strcmp(voipPort,"")==0 || strcmp(verbosed,"")==0 || strcmp(phonenr,"")==0 || strcmp(capi,"")==0){
		MessageBox(NULL, L"MConfig.txt does not give all information" ,L"Error", MB_OK);
		exit(0);
	}
    else
		return TRUE;
	
	return true;
}

//------------------------------------
// Breaks a string into two strings about
// a white space delimiter.
// This function does not allocate any memory
//-------------------------------------

BOOL BreakString(char *inp, char *str1, char *str2)
{
	
	int state =0;int st=0; int lst= 0;
	int quan=0;
	
	//	printf("STRING =\"%s\"\n",inp);
	for (int i=0; i < strlen(inp);i++){
		if (quan > 1)
			break;
		switch (state){
			
		case 0:
			if (inp[i] != ' ' && inp[i] != '\t'){
				st=i;
				state=1;
				break;
			}
			else
				break;
			
		case 1:
			if (inp[i] == ' ' || inp[i] == '\t' || inp[i]=='\n'){
				lst=i;
				state=0;
				if (quan ==0){
					for (int k=0; k <lst-st;k++)
						str1[k]=inp[st+k];
					str1[lst-st]='\0';
				} 
				else if (quan ==1){
					for (int k=0; k <lst-st;k++)
						str2[k]=inp[st+k];
					str2[lst-st]='\0';	
				}
				
				
                quan++; 
				break;
			}
			else
				break;
		}
	}
	
	if (quan == 2)
		return TRUE;
	else 
		return FALSE;
	
	
}

//-------------------------------
// Checks whether a string is empty
// i.e consists completely of white
// characters
//--------------------------------

BOOL IsEmptyString(char *inp){
	for (int k=0; k <strlen(inp);k++){
		if (isspace(inp[k])==0)
			return FALSE;
	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// FUNCTION: WriteHtmlDocument
//
// COMMENT: Write a html document to a file 
//
/////////////////////////////////////////////////////////////////////////////
DWORD WriteHtmlDocument(char * buffer)
{
	HANDLE hFile;
	DWORD dwBytesWrite;
	wchar_t wcError[MAX_STRING];
	
	wchar_t * g_pszStandardFileName = L"\\Windows\\browse.html";
	
	
	
	if ((hFile = CreateFile(g_pszStandardFileName,       
		GENERIC_WRITE | GENERIC_READ,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		CREATE_ALWAYS,
		FILE_ATTRIBUTE_NORMAL,
		NULL)) == INVALID_HANDLE_VALUE) {
		LPVOID lpMsgBuf;
		FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error CreateFile(): %s\r\n",lpMsgBuf);
        MessageBox(hwndMain,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
		return 0;
	}
	if (!WriteFile(hFile,buffer,strlen(buffer),&dwBytesWrite, NULL)) {
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error WriteFile(): %d\r\n",lpMsgBuf);
        MessageBox(hwndMain,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
		MessageBox(hwndMain,wcError,NULL,MB_OK);
		CloseHandle(hFile);
		return 0;
	}
	
	CloseHandle(hFile);
	
	return dwBytesWrite;
}





