// voiceclient.cpp : 

////#include "stdafx.h"
#include "voiceclient.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>

#include <mmreg.h>


// TODO: do something with this
// static CHtmlBlockingSocket g_sClient_VOIP;



// NOTE: The block size is in terms of bytes for 16 bit 
//       PCM speech samples. BLOCKSIZE = 2048 means 2048 bytes, 
//       or 1024 speech samples

#define RECORDBLOCKSIZE  2048
#define PLAYBLOCKSIZE    2048 

#define MAX_LOADSTRING 100

wchar_t recordFilename[256];
wchar_t playFilename[256];



/*
HANDLE record_hThread;   
HANDLE play_hThread;  
DWORD  record_dwThreadId;
DWORD  play_dwThreadId;
DWORD  WINAPI RecordThread(VOID *vptr);
DWORD  WINAPI PlayThread(VOID *vptr);
*/

// Global Variables:
// HINSTANCE			g_hInst;	// The current instance
HWND				g_hwndCB;		// The command bar handle
HANDLE              hAudioFile;
HWND				hWnd_Global;;		
DWORD               dwBytesWrite;




int globalCnt = 0;
int globalCntNothingFetchedFromSocket = 0;
// INT startRecord         = 0;   
// INT startRecordToSocket = 0;
// INT startPlay           = 0;   
// INT startPlayFromSocket = 0;  
INT blockCounter        = 0;
static short bufferPCM[32768];
static char  bufferALW[32768];
static short outputBufferPCM[PLAYBLOCKSIZE];
static char  outputBufferALW[PLAYBLOCKSIZE];
#define INITIALIZE_GLOBALS
#include "tables.h"



/*
WavRec  *wrobj;
WavPlay *wpobj;
*/




// *****************************RECORD SECTION ***************************************************
// *********************************************************************************************

WavRec::WavRec()  {

	WaveFormat.wFormatTag      = WAVE_FORMAT_PCM;
	WaveFormat.nChannels       = 1;
	WaveFormat.nSamplesPerSec  = 8000;
	WaveFormat.wBitsPerSample  = 16;
	WaveFormat.nBlockAlign     = WaveFormat.nChannels * (WaveFormat.wBitsPerSample >> 3);
	WaveFormat.nAvgBytesPerSec = WaveFormat.nSamplesPerSec * WaveFormat.nBlockAlign;
	WaveFormat.cbSize          = 0;

    //// MessageBox(hwndMain,L"ERROR: IN WavRec::WavRec() !!!!\n",NULL,MB_OK);
	// LPVOID lpMsgBuf;
	numBufRecorded = 0;	

	wchar_t   wcError[MAX_STRING];
	
	errAudioDevice = IsFormatSupported (&WaveFormat, WAVE_MAPPER);	
	if (errAudioDevice == MMSYSERR_NOERROR) {
		swprintf(wcError,L"Opening audio device: \r\nSuccess");
	}
	else {
		if (errAudioDevice == MMSYSERR_ALLOCATED) {
			swprintf(wcError,L"Opening audio device: \r\nSpecified resource is already allocated. ");
		}
		else if (errAudioDevice == MMSYSERR_BADDEVICEID) {
			swprintf(wcError,L"Opening audio device: \r\nSpecified device identifier is out of range. ");
		}
		else if (errAudioDevice == MMSYSERR_NODRIVER) {
			swprintf(wcError,L"Opening audio device: \r\nNo device driver is present. ");
		}
		else if (errAudioDevice == MMSYSERR_NOMEM){
			swprintf(wcError,L"Opening audio device: \r\nUnable to allocate or lock memory. ");
		}
		else if (errAudioDevice == WAVERR_BADFORMAT) {
			swprintf(wcError,L"Opening audio device: \r\n Attempted to open with an unsupported waveform-audio format.");
		}
		else {
			swprintf(wcError,L"Opening audio device: Unknown error\r\n");
			MessageBox(hwndMain,wcError,NULL,MB_OK);
			exit(0);
		}
		MessageBox(hwndMain,wcError,NULL,MB_OK);
	}
	


	if ( ! (Event = CreateEvent(0, FALSE, FALSE, 0))) {
		swprintf(wcError,L"Cannot create event.\r\n");
		MessageBox(hwndMain,wcError,NULL,MB_OK);
		exit(0);
	}
}

WavRec::~WavRec()
{   
	CloseHandle(Event);
}



/* ************************** RECORD:QueueWaveData() *****************************
 * Queues a buffer worth of data for the passed WAVEHDR. This is called
 * by my callback WaveOutProc().
 *
 * Returns a 0 for playback to continue. A -1 if an error. A 1 if the
 * wave has finished playing back and no more buffers need to be queued.
 */

long WavRec::QueueWaveData(WAVEHDR * waveHeader)
{

	blockCounter++;
	DWORD err;	

	short tmp1;
	char *tmp2;

	int cntMy = 0;
	for (int i=0;i<(int)WaveBufSize; i=i+2){
		tmp1             = 1* *(short *) (waveHeader->lpData +i);
		bufferPCM[cntMy++] = tmp1;
		tmp2             = (char *)(&tmp1);
		tmpbuf[i]        = *tmp2; tmpbuf[i+1] = *(tmp2+1);			
	}

	
		// Convert to alaw
		int SampleCnt;
		for (SampleCnt = 0; SampleCnt < (int)WaveBufSize/2; SampleCnt++) {
			bufferALW[SampleCnt] = AlawEncTab[2048 + ((bufferPCM[SampleCnt])>>4) ];		
		}		
		
		
        
		if (g_sClient_VOIP.m_bSocketCreated) {
			// Jek TODO: Need mutex for 100% stability
			g_sClient_VOIP.m_bSocketBusyWrite = true; 
			DWORD dwBytes = g_sClient_VOIP.Write(bufferALW, WaveBufSize/2, 4);
			g_sClient_VOIP.m_bSocketBusyWrite = false;
		}
		else {
			return(1);
		}
	

	// - we record for ever and ever until explicitly stopped
	/*
		if (numBufRecorded++ >= numBufToRec){
		MessageBox(hwndMain,L"Required number of buffers are done\n",NULL,MB_OK);
		return (1);
		}	
	*/

	// Unprepare the Header
	if ((err=waveInUnprepareHeader(HWaveIn, waveHeader, sizeof(WAVEHDR)))) {

        if      (err == MMSYSERR_NOERROR) {
		MessageBox(hwndMain,L"Cannot unprepare the header: Error:  MMSYSERR_NOERROR\n",NULL,MB_OK);
		}
		else if (err == MMSYSERR_INVALHANDLE) {
		MessageBox(hwndMain,L"Cannot unprepare the header: Error:  MMSYSERR_INVALHANDLE\n",NULL,MB_OK);
		}
		else if (err == MMSYSERR_NODRIVER) {
		MessageBox(hwndMain,L"Cannot unprepare the header: Error:  MMSYSERR_NODRIVER\n",NULL,MB_OK);
		}
		else if (err == MMSYSERR_NOMEM) {
		MessageBox(hwndMain,L"Cannot unprepare the header: Error:  MMSYSERR_NOMEM\n",NULL,MB_OK);
		}
		else if (err == WAVERR_STILLPLAYING) {
		MessageBox(hwndMain,L"Cannot unprepare the header: Error:  WAVERR_STILLPLAYING\n",NULL,MB_OK);
		}
		else {
		MessageBox(hwndMain,L"Cannot unprepare the header: Error:  Unknown\n",NULL,MB_OK);
		}	
		exit(0);
	}
	
	
	
	// Prepare the Header
	if ((err=waveInPrepareHeader(HWaveIn, waveHeader, sizeof(WAVEHDR)))) {
		MessageBox(hwndMain,L"Cannot prepare the header: Error = ?\n",NULL,MB_OK);
		exit(0);
	}

	// Queue the WAVEHDR 
	if ((err=waveInAddBuffer(HWaveIn, waveHeader, sizeof(WAVEHDR)))) {
       if (err == MMSYSERR_INVALHANDLE) {
		MessageBox(hwndMain,L"Cannot Add the header: Error:  MMSYSERR_INVALHANDLE\n",NULL,MB_OK);
		}
		else if (err == MMSYSERR_NOMEM ) {
		MessageBox(hwndMain,L"Cannot Add the header: Error:  MMSYSERR_NOMEM\n",NULL,MB_OK);
		}
		else if (err == WAVERR_UNPREPARED) {
		MessageBox(hwndMain,L"Cannot Add the header: Error:  WAVERR_UNPREPARED\n",NULL,MB_OK);
		}
		else {
		MessageBox(hwndMain,L"Cannot Add the header: Error:  Unknown\n",NULL,MB_OK);
		}			

		// Need to copy all data in the struct waveHeader to waveHeaderOut
		////memcpy(&WaveHeaderOut,&waveHeader,sizeof(waveHeader));
		memcpy(&lpHdr,&waveHeader,sizeof(waveHeader));
		//// WaveHeaderOutCurrent = &WaveHeaderOut;
		if ((err = waveOutPrepareHeader(HWaveOut, lpHdr, sizeof(WAVEHDR)))) {
			MessageBox(hwndMain,L" ERROR: preparing output WAVEHDR\n",NULL,MB_OK);
			exit(0);
		}
		// AudioOut Queue the WAVEHDR 
		if ((err=waveOutWrite(HWaveOut, lpHdr, sizeof(WAVEHDR)))){
			MessageBox(hwndMain,L"Cannot play frame\n",NULL,MB_OK);
			exit(0);
		}		
		exit(0);
	}


	// Allow recording  to continue 
	return(0);	
	
	
}



/*  ************************* RECORD:WaveInProc() ***************************************
 * 
 * Callback. This is called by Windows every time that some event
 * needs to be handled by my program.
 */
void  CALLBACK WavRec::WaveInProc(HWAVEIN waveIn, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	if (uMsg == WIM_DATA)
	{
		curWaveHeader = (WAVEHDR *) dwParam1;
	    SetEvent(Event);
	}
}




/*************************** RECORD:RecordWave() *************************************
 *
 * Prepare for record.
 * The WAVEFORMATEX structure (ie, WaveFormat) has already been filled in?
 */

// void WavRec::RecordWave(DWORD rec_nbuf)
void WavRec::RecordWave()
{

	DWORD	err;
	// numBufToRec= rec_nbuf;
	
	// Open the default WAVE Input Device, specifying my callback 
	if ((err = waveInOpen(&HWaveIn, WAVE_MAPPER, &WaveFormat, (DWORD)(::WaveInProc), 0, CALLBACK_FUNCTION)))
	{
		MessageBox(hwndMain,L"ERROR: Can't open WAVE In Device!\n",NULL,MB_OK);
		exit(0);	
	}


	// FJERNES ???
	//   jek AudioOut
	//   Open the default WAVE Out Device, specifying my callback 
	//// if ((err = waveOutOpen(&HWaveOut, WAVE_MAPPER, &WaveFormat, (DWORD)(::WaveInProc), 0, CALLBACK_FUNCTION)))
	if ((err = waveOutOpen(&HWaveOut, WAVE_MAPPER, &WaveFormat, NULL, 0, CALLBACK_FUNCTION)))
	{
		MessageBox(hwndMain,L"Can't open WAVE Out Device! \n",NULL,MB_OK);
		exit(0);
	}
	


	/* 
	   Allocate 2 buffers large enough to hold 2 seconds worth of waveform data. NOTE: Just to make it
	   easy, I'll use 1 call to VirtualAlloc to allocate both buffers, but you can use 2 separate calls since
	   the buffers do NOT need to be contiguous 
	*/
	
	
	//// WaveBufSize = WaveFormat.nAvgBytesPerSec << 1;  // Multiplied by 2
	//// wchar_t   wcError[MAX_STRING];
	//// swprintf(wcError,L"WaveBufSize = %d\r\n",WaveBufSize);
	//// MessageBox(hwndMain,wcError,NULL,MB_OK);
	


	WaveBufSize = RECORDBLOCKSIZE;

	tmpbuf= new char[WaveBufSize];

	if (!(WaveHeader[0].lpData = (LPSTR)VirtualAlloc(0, WaveBufSize<<1, MEM_COMMIT, PAGE_READWRITE)))
	{
		MessageBox(hwndMain,L"ERROR: Can't allocate memory for WAVE buffer!\n",NULL,MB_OK);
		exit(0);

	}

	// Fill in WAVEHDR fields for buffer starting address and size 
	WaveHeader[0].dwFlags =0;
	WaveHeader[1].dwFlags =0;	
	WaveHeader[1].lpData = WaveHeader[0].lpData + WaveBufSize;
	WaveHeader[1].dwBufferLength = WaveHeader[0].dwBufferLength = WaveBufSize;


	//  AudioIn Prepare the 2 WAVEHDR's 
	if ((err = waveInPrepareHeader(HWaveIn, &WaveHeader[0], sizeof(WAVEHDR))))
	{
		MessageBox(hwndMain,L"ERROR: preparing WAVEHDR 1! -- \n",NULL,MB_OK);
		exit(0);
	}
	if ((err = waveInPrepareHeader(HWaveIn, &WaveHeader[1], sizeof(WAVEHDR))))
	{		
		MessageBox(hwndMain,L"ERROR: preparing WAVEHDR 2!\n",NULL,MB_OK);
		exit(0);
	}

	waveInAddBuffer(HWaveIn, &WaveHeader[0], sizeof(WAVEHDR));
    waveInAddBuffer(HWaveIn, &WaveHeader[1], sizeof(WAVEHDR));

	if ( !(err=waveInStart(HWaveIn))){

		while (1) {
			WaitForSingleObject(Event, INFINITE);
			if (QueueWaveData(curWaveHeader)) {ResetEvent(Event);break;}
			ResetEvent(Event);
		}
	}
	else {
		fprintf(stderr, "could not start recording due to error \n");
	exit(0);
	}


	// Stop Windows queuing of buffers (and calling of my callback) 
	waveInReset(HWaveIn);
	// Unprepare WAVE buffers 
	waveInUnprepareHeader(HWaveIn, &WaveHeader[1], sizeof(WAVEHDR));
	waveInUnprepareHeader(HWaveIn, &WaveHeader[0], sizeof(WAVEHDR));
	// Free WAVE buffers 
	VirtualFree(WaveHeader[0].lpData, WaveBufSize<<1, MEM_FREE);
	// Close WAVE Out device 
	waveInClose(HWaveIn);
	// AudioOut  Stop Windows queuing of buffers (and calling of my callback) 
	waveOutReset(HWaveOut);
	// Unprepare WAVE buffers 
	waveOutUnprepareHeader(HWaveOut, lpHdr, sizeof(WAVEHDR));
	// Free WAVE buffers 
	////VirtualFree(WaveHeader[0].lpData, WaveBufSize<<1, MEM_FREE);
	// Close WAVE Out device 
	waveOutClose(HWaveOut);
	

}

/*
void  CALLBACK WaveInProc(HWAVEIN waveIn, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	wrobj->WaveInProc(waveIn, uMsg, dwInstance, dwParam1,dwParam2);
}
*/


MMRESULT WavRec::IsFormatSupported (LPWAVEFORMATEX pwfx, UINT uDeviceID) 
{ 
    return waveOutOpen (NULL,               // ptr can be NULL for query
                        uDeviceID,          // The device identifier 
                        pwfx,               // Defines the requested  
                        NULL,               // No callback 
                        NULL,               // No instance data 
                        WAVE_FORMAT_QUERY); // Query only, do not open.
}











// *****************************PLAY SECTION ***************************************************
// *********************************************************************************************


WavPlay::WavPlay()
{
	WaveFormat.wFormatTag = WAVE_FORMAT_PCM;
	WaveFormat.nChannels = 1;
	WaveFormat.nSamplesPerSec = 8000;
	WaveFormat.wBitsPerSample = 16;
	WaveFormat.nBlockAlign = WaveFormat.nChannels * (WaveFormat.wBitsPerSample >> 3);
	WaveFormat.nAvgBytesPerSec = WaveFormat.nSamplesPerSec * WaveFormat.nBlockAlign;
	WaveFormat.cbSize = 0;
	

	if ( ! (Event = CreateEvent(0, FALSE, FALSE, 0)))
	{
		MessageBox(hwndMain,L"Error CreateEvent\n",NULL,MB_OK);
		exit(0);
	}

	
    // Tricky if you want to play from local file (e.g. sound effects)
	// PlaySound((const unsigned short *)&tmpbuf[0], NULL, SND_MEMORY | SND_ASYNC);


}



WavPlay::~WavPlay()
{   
	CloseHandle(Event);
}


int WavPlay::SetSampRate(int r)
{
	WaveFormat.nSamplesPerSec = r;
	return 0;
}


/* ************************** PLAY:QueueWaveData() *****************************
 * Queues a buffer worth of data for the passed WAVEHDR. This is called
 * by my callback WaveOutProc().
 *
 * Returns a 0 for playback to continue. A -1 if an error. A 1 if the
 * wave has finished playing back and no more buffers need to be queued.
 */

long WavPlay::QueueWaveData(WAVEHDR * waveHeader)
{

	DWORD err;	

	DWORD dwBytesRead;
	DWORD dwMaxSize = 10000;
	wchar_t wcError[MAX_STRING] = {0};





		// Read data from socket
		char tmpBuf[PLAYBLOCKSIZE];
		// Alternatively use wait = 0
		if ( (dwBytesRead = (DWORD)g_sClient_VOIP.ReadNbytes(tmpBuf, WaveBufSize/2, 0)) < 0) {
			waveOutPause(HWaveOut);
			MessageBox(hwndMain,L"Error reading from socket !!!!!\n",NULL,MB_OK);
			CloseHandle(hAudioFile);
			return 1;
		}


		int i;
		int charCnt = 0;
		for (i=0; i < (int)WaveBufSize/2; i++) {
			outputBufferPCM[i] = AlawDecTab[(unsigned char)tmpBuf[i]];
			* (short *)(waveHeader->lpData + charCnt) = outputBufferPCM[i];
			charCnt = charCnt + 2;
		}
		dwBytesRead = dwBytesRead * 2;



	if (!dwBytesRead) {
	// If no data fetched, play silence	
	// dirty
		int i;
		int charCnt = 0;
		for (i=0; i < (int)WaveBufSize/2; i++) {
			short tmp1 = 0;
			* (short *)(waveHeader->lpData + charCnt) = tmp1;
			charCnt = charCnt + 2;
		}
		dwBytesRead = WaveBufSize;
		globalCntNothingFetchedFromSocket++;
	}


	waveHeader->dwBufferLength = (DWORD)dwBytesRead;

	// Queue the WAVEHDR 
	if ((err=waveOutWrite(HWaveOut, waveHeader, sizeof(WAVEHDR)))){
		waveOutPause(HWaveOut);
		MessageBox(hwndMain,L"ERROR: waveOutWrite\n",NULL,MB_OK);
		waveOutClose(HWaveOut);
		exit(0);
	}

	// Allow playing   to continue 
	return(0);	
		
}



/* ************************** PLAY:WaveOutProc() *****************************
 * My WAVE callback. This is called by Windows every time that some event
 * needs to be handled by my program.
 */
void  CALLBACK WavPlay::WaveOutProc(HWAVEOUT waveOut, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	// Has a buffer finished playing? 
	if (uMsg == WOM_DONE)
	{
		curWaveHeader = (WAVEHDR *) dwParam1;
	    SetEvent(Event);
	}
}



/* ************************** PLAY:PlayWave() *****************************
 * Plays the WAVE. It is presumed that HMmio is an open MultiMedia File
 * handle, currently pointing to the start of the waveform data.
 * WaveDataPlayed is set to the total number of bytes in the waveform.
 * The WAVEFORMATEX structure (ie, WaveFormat) has already been filled
 * in.
 */
void WavPlay::PlayWave(wchar_t * pwcFileName )

{

	DWORD	err;
	wchar_t wcError[MAX_STRING] = {0};
	

	// Open the default WAVE Out Device, specifying my callback 
	if ((err = waveOutOpen(&HWaveOut, WAVE_MAPPER, &WaveFormat, (DWORD)(::WaveOutProc), 0, CALLBACK_FUNCTION)))
	{
		MessageBox(hwndMain,L"Can't open WAVE Out Device! \n",NULL,MB_OK);
		exit(0);
	}


	/* 
	   Allocate 2 buffers large enough to hold 2 seconds worth of waveform data. NOTE: Just to make it
	   easy, I'll use 1 call to VirtualAlloc to allocate both buffers, but you can use 2 separate calls since
	   the buffers do NOT need to be contiguous 
	*/
	
	//WaveBufSize = WaveFormat.nAvgBytesPerSec; // << 1;  // Multiplied by 2
    WaveBufSize = PLAYBLOCKSIZE; 

	if (!(WaveHeader[0].lpData = (LPSTR)VirtualAlloc(0, WaveBufSize<<1, MEM_COMMIT, PAGE_READWRITE)))
	{
		MessageBox(hwndMain,L"Can't allocate memory for WAVE buffer \n",NULL,MB_OK);
		exit(0);

	}

	// Fill in WAVEHDR fields for buffer starting address and size  
	WaveHeader[0].dwFlags =0;
	WaveHeader[1].dwFlags =0;	
	WaveHeader[1].lpData = WaveHeader[0].lpData + WaveBufSize;
	WaveHeader[1].dwBufferLength = WaveHeader[0].dwBufferLength = WaveBufSize;
	// Leave other WAVEHDR fields at 0  
	

	// Prepare the 2 WAVEHDR's  
	if ((err = waveOutPrepareHeader(HWaveOut, &WaveHeader[0], sizeof(WAVEHDR))))
	{
		MessageBox(hwndMain,L" preparing WAVEHDR 1!  \n",NULL,MB_OK);
		exit(0);
	}
	if ((err = waveOutPrepareHeader(HWaveOut, &WaveHeader[1], sizeof(WAVEHDR))))
	{		
		MessageBox(hwndMain,L"ERROR: preparing WAVEHDR 2! -  \n",NULL,MB_OK);
		exit(0);
	}

	int breaknext=-1;
	if ((breaknext=QueueWaveData(&WaveHeader[0])) ==0) {
		if ((breaknext=QueueWaveData(&WaveHeader[1])) >= 0) { 
			while(1) {
				WaitForSingleObject(Event, INFINITE);
				breaknext = QueueWaveData(curWaveHeader);
				if (breaknext) break;					
				ResetEvent(Event);

			}
			////WaitForSingleObject(Event, INFINITE);
		}
	}
	else if (breaknext == 1) {
	    MessageBox(hwndMain,L" - play/record end !!!!!!!!!!!!!!!!!!\n",NULL,MB_OK);
		WaitForSingleObject(Event, INFINITE);	
	}
	else  {
	     MessageBox(hwndMain,L"ERROR: ?? \n",NULL,MB_OK);
	}


	// Stop Windows queuing of buffers (and calling of my callback) 
	waveOutReset(HWaveOut);
	// Unprepare WAVE buffers 
	waveOutUnprepareHeader(HWaveOut, &WaveHeader[1], sizeof(WAVEHDR));
	waveOutUnprepareHeader(HWaveOut, &WaveHeader[0], sizeof(WAVEHDR));
	// Free WAVE buffers 
	VirtualFree(WaveHeader[0].lpData, WaveBufSize<<1, MEM_FREE);
	// Close WAVE Out device 
	waveOutClose(HWaveOut);
}


/*
void  CALLBACK WaveOutProc(HWAVEOUT waveOut, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	wpobj->WaveOutProc(waveOut, uMsg, dwInstance, dwParam1,dwParam2);
}
*/

