


#ifndef __WAVEREC_HH__
#define __WAVEREC_HH__

#include <windows.h>
#include <stdio.h>
//// #include <conio.h>
#include <mmsystem.h>
//// #include <malloc.h>


//// #include <iostream>
//// #include <fstream>
//// using namespace std;

class WavRec{


public:




	
	
int bufn;
HANDLE hAudioFile;
MMRESULT errAudioDevice;

#define SOUNDSAMPLES 1000


private:


/* Name of the WAVE file */
char 		*RawName;  //= "C:\\WINNT\\MEDIA\\CTMELODY.WAV";

/* WAVEFORMATEX structure for reading in the WAVE fmt chunk */
WAVEFORMATEX WaveFormat;


/* file handle for open file */
HMMIO		HMmio;

/* subchunk information structure for reading WAVE file */
// MMCKINFO    MmckinfoSubchunk;

/* Count of waveform data still to play */
DWORD		WaveDataPlayed;


/* Handle of opened WAVE In/Out device */
HWAVEIN	 HWaveIn;
HWAVEOUT HWaveOut;

/* The size of each WAVEHDR's wave buffer */
DWORD		WaveBufSize;

/* 2 WAVEHDR structures (for double-buffered playback of WAVE) */
WAVEHDR		WaveHeader[2];


/* 2 WAVEHDR structures (for double-buffered playback of WAVE) */
WAVEHDR		WaveHeaderOut;


WAVEHDR	*	WaveHeaderOutCurrent;

/* Ptr to last WAVEHDR played */
WAVEHDR *	LastHdr;

WAVEHDR *   curWaveHeader; 


LPWAVEHDR lpHdr;


/* Event used by callback to signal main thread */
HANDLE		Event;

// Number of buffers recorded
DWORD     numBufRecorded;
DWORD     numBufToRec; 

//// ofstream  OutRawFD; 

MSG       my_cbmessage;
// UINT      MY_WIM_DATA;  
char *tmpbuf;
 

public:

	WavRec();
	~WavRec();
	long QueueWaveData(WAVEHDR * waveHeader);
	long QueueWaveData_new();	
	void CALLBACK WaveInProc(	HWAVEIN waveIn, 
								UINT uMsg, 
								DWORD dwInstance, 
								DWORD dwParam1, 
								DWORD dwParam2);
	
	void CALLBACK WaveInProc_new(HWAVEIN waveIn, 
								UINT uMsg, 
								DWORD dwInstance, 
								DWORD dwParam1, 
								DWORD dwParam2);

	void RecordWave();


	MMRESULT IsFormatSupported (LPWAVEFORMATEX pwfx, UINT uDeviceID);

};

extern "C" {
	void CALLBACK WaveInProc(	HWAVEIN waveIn, 
								UINT uMsg, 
								DWORD dwInstance, 
								DWORD dwParam1, 
								DWORD dwParam2);
};





#endif

