// WebBrowser_Win32.cpp : Defines the entry point for the application.
//

//#include "stdafx.h"
#include <atlbase.h>
#include <winuser.h>
CComModule _Module;
#include <commctrl.h>
#include <atlcom.h>
#include <atlwin.h>
#include <exdisp.h>  
#include "WebBrowser.h"


// NOTE: See the template parameter. Its CMcbWindow
class CMcbWindow : public CWindowImpl<CMcbWindow> 
{
	// START MESSAGE_MAP
   BEGIN_MSG_MAP( CMcbWindow )
      MESSAGE_HANDLER( WM_PAINT, OnPaint )
      MESSAGE_HANDLER( WM_DESTROY, OnDestroy )
	  MESSAGE_HANDLER( WM_COMMAND, OnCommand )
	  MESSAGE_HANDLER( WM_CREATE, OnCreate )
   END_MSG_MAP()
   // END MESSAGE_MAP
 
   // This function will paint a Hello mindcracker string 
   LRESULT OnPaint( UINT, WPARAM, LPARAM, BOOL& )
   {
      PAINTSTRUCT ps;
	  if(m_hWnd !=NULL) {
		HDC hDC = GetDC();
		BeginPaint( &ps );
		EndPaint( &ps );
		ReleaseDC(hDC);
	  }
      return 0;
   }
 
	LRESULT OnDestroy( UINT, WPARAM, LPARAM, BOOL& ){
		//if(hwndExit)	::DestroyWindow(hwndExit);
		if(hwndBrowse)  ::DestroyWindow(hwndBrowse);
		if(hwndEdit)    ::DestroyWindow(hwndEdit);
		if(hwndCombo)   ::DestroyWindow(hwndEdit);
		PostQuitMessage(0);
		return 0;
	}

   LRESULT OnCommand(
	     UINT    uMsg,
		WPARAM  wParam,
		LPARAM  lParam,
		BOOL &  bHandled)
   {
	   int wmId, wmEvent;
	   wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(lParam); 
		// Parse the menu selections:
		switch (wmId)
		{	
			case IDM_HELP_ABOUT:
				DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, m_hWnd, (DLGPROC)About);
				break;
			case IDM_HELP_CONNECT:
				DialogBox(g_hInst, (LPCTSTR)IDD_CONNECT, m_hWnd, (DLGPROC)ConnectDlgProc);
				break;
			case IDM_START:
				::SendMessage(m_hWnd,WM_COMMAND,IDC_START,0);
				break;
			case IDM_BACK:
				::SendMessage(m_hWnd,WM_COMMAND,IDC_BACK,0);
				break;
			// Menu manupulation for the debug window
			case IDM_DEBUG_WIN:
				{
					if(g_dwDebugChecked == MF_CHECKED) {
						g_dwDebugChecked = CheckMenuItem(hMenu,IDM_DEBUG_WIN,MF_BYCOMMAND | MF_UNCHECKED);
						g_dwBrowseGrayed = EnableMenuItem(hMenu,IDM_BROWSE_WIN, MF_BYCOMMAND | MF_ENABLED);
						if (g_dwDebugChecked == MF_CHECKED)
							g_dwDebugChecked = MF_UNCHECKED;
						// Hide the edit window
						::ShowWindow(hwndEdit,SW_HIDE);
						RECT rc;
						::GetClientRect(axwnd,&rc);
						::MoveWindow(axwnd,axrc.left,axrc.top - 36,axrc.right-axrc.left,axrc.bottom-axrc.top + 36,TRUE);
						
					} else if (g_dwDebugChecked == MF_UNCHECKED){
						g_dwDebugChecked = CheckMenuItem(hMenu,IDM_DEBUG_WIN,MF_BYCOMMAND | MF_CHECKED);
						if (g_dwDebugChecked == MF_UNCHECKED)
							g_dwDebugChecked = MF_CHECKED;
						g_dwBrowseGrayed = EnableMenuItem(hMenu,IDM_BROWSE_WIN, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
						::MoveWindow(axwnd,axrc.left,axrc.top,axrc.right-axrc.left,axrc.bottom-axrc.top,TRUE);
						// Show the edit window
						::ShowWindow(hwndEdit,SW_SHOW);
						
					}
				}
				break;
			// Menu manupulation for the browse window
			case IDM_BROWSE_WIN:
				{
					if(g_dwBrowseChecked == MF_CHECKED) {
						g_dwBrowseChecked = CheckMenuItem(hMenu,IDM_BROWSE_WIN,MF_BYCOMMAND | MF_UNCHECKED);
						if (g_dwBrowseChecked == MF_CHECKED)
							g_dwBrowseChecked = MF_UNCHECKED;
						g_dwDebugGrayed = EnableMenuItem(hMenu,IDM_DEBUG_WIN, MF_BYCOMMAND | MF_ENABLED);
						// Destroy window
						::ShowWindow(hwndBrowse,SW_HIDE);
						::ShowWindow(hwndCombo,SW_HIDE);
						  RECT rc;
						::GetClientRect(axwnd,&rc);
						::MoveWindow(axwnd,axrc.left,axrc.top - 36,axrc.right-axrc.left,axrc.bottom-axrc.top + 36,TRUE);
						//::MoveWindow(axwnd,rc.left,rc.top - 36,rc.right-rc.left,rc.bottom-rc.top + 36,TRUE);
 
					} else if (g_dwBrowseChecked == MF_UNCHECKED){
						g_dwBrowseChecked = CheckMenuItem(hMenu,IDM_BROWSE_WIN,MF_BYCOMMAND | MF_CHECKED);
						if (g_dwBrowseChecked == MF_UNCHECKED)
							g_dwBrowseChecked = MF_CHECKED;
						g_dwDebugGrayed = EnableMenuItem(hMenu,IDM_DEBUG_WIN, MF_BYCOMMAND | MF_ENABLED | MF_GRAYED);
						::MoveWindow(axwnd,axrc.left,axrc.top,axrc.right-axrc.left,axrc.bottom-axrc.top,TRUE);
						// Create window
						::ShowWindow(hwndBrowse,SW_SHOW);
						::ShowWindow(hwndCombo,SW_SHOW);
					}
				}
				break;
			case IDOK:
				//::SendMessage(hWnd, WM_ACTIVATE, MAKEWPARAM(WA_INACTIVE, 0), (LPARAM)hWnd);
				SendMessage (m_hWnd, WM_CLOSE, 0, 0);
				break;
			// Write data to the socket
			case IDC_SEND_TO_SOCKET:
				{
				char sData[MAX_STRING];
				//strcpy(sData,"MMODALINF\r\n");
				wcstombs(sData,(PWCHAR)lParam,200);
				strcat(sData,"\r\n");
				DWORD dwDataLength = strlen(sData);
				if (g_sClient.m_hSocket) {
					// Write to the socket
					DWORD dwBytes = g_sClient.Write(sData, dwDataLength, 4);
					if(dwBytes != dwDataLength) {
						//Error?
					}
				}
				}
				break;
			case IDC_START:
				{
					// Browse to the start URL
					
					::SetWindowText(hwndEdit,(PWCHAR)startURL);

					DWORD dwCount = ::SendMessage(hwndCombo,CB_GETCOUNT,0,0);

					for(DWORD i = 0 ; i < dwCount; i++) {
						::SendMessage(hwndCombo,CB_DELETESTRING,0,0);
					}
					NavigateURL(startURL);
				}
				break;
			case IDC_BACK:
				{
					// Browse to the last URL
					
					WCHAR szTemp[256] = {0};
					
					DWORD dwCount = ::SendMessage(hwndCombo,CB_GETCOUNT,0,0);
					
					// Rotate items in the combo box
					WCHAR szItem[256] = {0};
					::SendMessage(hwndCombo,CB_GETLBTEXT,(dwCount - 1),(LPARAM)(LPCSTR)szItem);
					::SendMessage(hwndCombo,CB_INSERTSTRING,0,(LPARAM)(LPCSTR)szItem);
					::SendMessage(hwndCombo,CB_DELETESTRING,dwCount,0);
						
					VARIANT vFlags = {0},
					vTargetFrameName = {0},
					vPostData = {0},
					vHeaders = {0};

					WCHAR szNavigate[256] ={0};

					if(dwCount > 1)
						::SendMessage(hwndCombo,CB_GETLBTEXT,(dwCount -1),(LPARAM)(LPCSTR)szNavigate);
						::SendMessage(hwndCombo,WM_SETTEXT,0,(LPARAM)szNavigate);

					pBrowser->Navigate(szNavigate, &vFlags,
						&vTargetFrameName, &vPostData, &vHeaders);
				}
				break;
			// Parse the data from the ActiveX control
			case IDC_PARSE_DATA:
				{
					::SendMessage(hwndEdit,EM_REPLACESEL,FALSE,(LPARAM)L"PARSE DATA");
					// Raise the keyboard
					if(!_wcsnicmp((PWCHAR)lParam,L"RAISEKEYBOARD",wcslen(L"RAISEKEYBOARD"))) {
#ifdef _WIN32_WCE
						RaiseSip();
#endif
					// Lower the keyboard
					}else if (!_wcsnicmp((PWCHAR)lParam,L"LOWERKEYBOARD",wcslen(L"LOWERKEYBOARD"))) {
#ifdef _WIN32_WCE
						LowerSip();
#endif
					// Send map events to the server
					} else {
						::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)lParam);
					}
				}
				break;
			case IDC_COMBO:
					{
						DWORD dwSel,dwError;
						WCHAR szItem[256];
						if(HIWORD(wParam) == CBN_SELENDOK) {
							dwSel= ::SendMessage(hwndCombo,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
							dwError = ::SendMessage(hwndCombo,CB_GETLBTEXT,(WPARAM)dwSel,(LPARAM)szItem);
							if(dwError != CB_ERR) {
								::SendMessage(hwndCombo,WM_SETTEXT,(WPARAM)0,(LPARAM)(LPCTSTR)szItem); 
							}
						}
					}
					break;
			case IDC_BROWSE:
					{
					//::DialogBox(/*ghInst*/g_hInst, MAKEINTRESOURCE(IDD_BROWSE), hWnd, BrowseDlgProc);
					WCHAR szItem[256]; 
					::SendMessage(hwndCombo,WM_GETTEXT,(WPARAM)100,(LPARAM)szItem); 
					NavigateURL(szItem);
					}
					break;
			case IDC_QUESTION:
				break;
			case IDC_EXIT:
				//if(hwndExit) ::DestroyWindow(hwndExit);
				if(hwndBrowse) ::DestroyWindow(hwndBrowse);
				if(hwndEdit) ::DestroyWindow(hwndEdit);
				if(hwndCombo) ::DestroyWindow(hwndCombo);
		
				::PostQuitMessage(0);
				break;
		}
				
	return 0;
   }

   LRESULT OnCreate( UINT, WPARAM, LPARAM, BOOL& )
   {
	   	// Create the commando bar with bitmap buttons .
		
	   //hwndExit = CreateExitWindow();
	   hwndBrowse = CreateBrowseWindow();
	   hwndEdit   = CreateEditWindow();
	   hwndCombo  = CreateComboWindow();

		for (int i = 0; i < sizeof(logURL)/sizeof(logURL[0]); i++) 
			wcscpy(&logURL[i][0],L"");

		wcscpy(lastURL,L"");
		wcscpy(startURL,L"");
		bStartURL = TRUE;

	return 0;
   }
};

CMcbWindow atlWnd; 

int WINAPI _tWinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
		
	MSG msg;
	HACCEL hAccelTable;

	_Module.Init(NULL, hInstance);
	AtlAxWinInit(); 
	CWindow cw;
	
	RECT rc = {0,0,250,308 + dwToolbarHeight};

	// Create the main window
	atlWnd.Create(NULL,rc, _T("WebBrowser"),
      WS_OVERLAPPEDWINDOW);

	// Center the window
	atlWnd.CenterWindow();

	// Show the window
	atlWnd.ShowWindow(1);	
 
	// Create an ActiveX control inside the main window
	axwnd.Create(atlWnd, axrc, _T("{8856F961-340A-11D0-A96B-00C04FD705A2}"), WS_CHILD | WS_VISIBLE|     
	WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_CLIENTEDGE);
	

	HRESULT hr;
	VARIANT vFlags = {0},
    vTargetFrameName = {0},
    vPostData = {0},
    vHeaders = {0};

	// Get a pointer to the interface IWebBrowser 
	hr = axwnd.QueryControl(IID_IWebBrowser,(void**)&pBrowser);

    if(SUCCEEDED(hr)) {
		BSTR bsURL;
		// A test URL
        bsURL = SysAllocString(L"C:\\Temp\\user\\examples32\\example2.htm");
        // Browse the URL
		hr = pBrowser->Navigate(bsURL, &vFlags,
          &vTargetFrameName, &vPostData, &vHeaders);
		if (bsURL) SysFreeString(bsURL);
    } else {
       ::MessageBox(axwnd, TEXT("QueryControl of IWebBrowser Failed"), NULL, MB_OK);
    }

	// Create a thread that reads data from a socket
	g_hThread = CreateThread(NULL,0,SocketThread,(LPVOID) NULL,CREATE_SUSPENDED,&g_dwThreadId);

	// Create menu
    hMenu = LoadMenu(hInstance,(LPCTSTR)IDM_MENU);
	BOOL bMenu= SetMenu(atlWnd,hMenu);

	// Create menu bar
	HWND hToolBar = CreateToolbarEx(atlWnd,	WS_CHILD | WS_VISIBLE, IDR_TOOLBAR1,3, 	
		hInstance, IDB_BITMAP_CMDBAR, tbButton, sizeof(tbButton)/sizeof(TBBUTTON), 
		16, 18, 50, 16, sizeof(TBBUTTON));	


	RECT rct;
	GetClientRect(hToolBar,&rct);

	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		if(msg.hwnd == NULL) {
			::SetWindowText(hwndEdit,(PWCHAR)msg.lParam);
			// Sends data from mapctrl.dll into the WinProc's message loop
			::SendMessage(hwndMain,WM_COMMAND,(WPARAM)IDC_PARSE_DATA,(LPARAM)msg.lParam);
		}
      TranslateMessage( &msg );
      DispatchMessage( &msg );
	}

	 _Module.Term();

	return (msg.wParam);

}


/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: NavigateURL
//
//  COMMENT: Navigate URL and save save the URL address 
//           
/////////////////////////////////////////////////////////////////////////////
void NavigateURL(PWCHAR pszURL)
{
	::SendMessage(hwndCombo,CB_ADDSTRING,0,(LPARAM)(LPCSTR)pszURL);
	DWORD dwCount = ::SendMessage(hwndCombo,CB_GETCOUNT,0,0);
	
	if(g_dwMaxURL < dwCount)
		::SendMessage(hwndCombo,CB_DELETESTRING,--dwCount,0);
// Comment out an array that contains the URL addresses
#if 0
	int i;
	if(bStartURL) {
		wcscpy(startURL,pszURL);
		bStartURL = FALSE;
	}
	
	DWORD dwCount = ::SendMessage(hwndCombo,CB_GETCOUNT,0,0);
	DWORD dwRemain=0;
	for (i = 0; i < dwCount; i++) {
			dwRemain=::SendMessage(hwndCombo,CB_DELETESTRING,0,0);
	}

	// Hold track of the URL's in an array

	if(wcslen(logURL[0]) != 0)
		wcscpy(lastURL,logURL[0]);
	else
		wcscpy(lastURL,startURL);

	TCHAR tempURL[(sizeof(logURL)/sizeof(logURL[0]))][MAX_STRING];

	for (i = 0; i < (sizeof(logURL)/sizeof(logURL[0])); i++) {
			memset(tempURL[i],0,sizeof(logURL[0]));
			wcscpy(tempURL[i],logURL[i]);
	}
	
	for (i = 1; i < (sizeof(logURL)/sizeof(logURL[0])); i++) {
			wcscpy(logURL[i],tempURL[i-1]);
	}

	wcscpy(logURL[0],pszURL);

	// Add the items to a combo box
	for (i = 0; i < (sizeof(logURL)/sizeof(logURL[0])); i++) {
		if((wcslen(logURL[i]) != 0)) 
			::SendMessage(hwndCombo,CB_ADDSTRING,0,(LPARAM)(LPCSTR)logURL[i]);
	}
#endif
	VARIANT vFlags = {0},
    vTargetFrameName = {0},
    vPostData = {0},
    vHeaders = {0};
	
	pBrowser->Navigate(pszURL, &vFlags,
          &vTargetFrameName, &vPostData, &vHeaders);	
}


/////////////////////////////////////////////////////////////////////////////
// FUNCTION: SocketThread
//
// COMMENT: Reads commands from a socket. Support command for 1) exit 
//          program, 2) upload a html-file and save it and 3) browse
//          html-files directly.
//   
/////////////////////////////////////////////////////////////////////////////
DWORD WINAPI SocketThread(LPVOID lParam) {
	
	char * buffer = new char[MAXBUF];
	int nBytesReceived = 0, nBytesWrite = 0, nTextSize = 0;
	char * startPath;
	
	do {
		memset(buffer,0,MAXBUF);
		// Read the document header
		if (nBytesReceived = g_sClient.ReadLine(buffer,MAX_STRING, 6)) {
			// Read a html documet and save it on the hard-disc
			if(strstr(buffer,"HTMLBODY")) {
				if ((nBytesReceived = g_sClient.ReadLine(buffer,MAX_STRING, 1)) && (nTextSize = atoi(buffer))) {
					if((nBytesReceived = g_sClient.ReadText(buffer,nTextSize,1)) != nTextSize) {
						::MessageBox(hwndMain,L"Can't read text. ReadText()",L"WINSOCK CLIENT", MB_OK);
					} else {
						buffer[nBytesReceived] = '\0';
						nBytesWrite = WriteHtmlDocument(buffer);
					} 
				} else {
					::MessageBox(hwndMain,L"Can't read the correct\r\n order of bytes\r\n from socket. ReadLine()",L"WINSOCK CLIENT", MB_OK);
				}
			// Exit program
			} else if (strstr(buffer,"DISCONNECT")) {
				exit(0);
			// Read a browse command and it's URL address and browse
			// against this address
			} else if(startPath = strstr(buffer,"BROWSEFILE")) {
				WCHAR wcTemp[MAX_STRING];
				memset(wcTemp,0,sizeof(wcTemp));
				strcpy(buffer,&startPath[strlen("BROWSEFILE")]);
				buffer[strlen(buffer)] = '\0';
				mbstowcs(wcTemp,buffer,strlen(buffer));
				wcscpy(g_pszFileName,wcTemp);
				NavigateURL(wcTemp);
			}
		} else {
			// The socket server is closed =>
			// close the socket and suspend the socket thread
			g_sClient.Close();
			SuspendThread(g_hThread);
		}
	}
	while(!g_bKillThread);

	g_sClient.Close();
	
	if (buffer) delete [] buffer;
	
	return 0; // The thread exit
}


/////////////////////////////////////////////////////////////////////////////
// FUNCTION: ConnectDlgProc
//
// COMMENT:Create a dialog box that can be used to set up a socket 
//	       communication to a server program.  
//          
/////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK ConnectDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32_WCE
	SHINITDLGINFO shidi;
#endif
	HWND hWnd;
	DWORD size = 0;

	switch (message)
	{
		case WM_INITDIALOG:
			{
				hwndConnect = hDlg;  
#ifdef _WIN32_WCE
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);
#endif
                // Put text into the combo box
				HWND hWndCombo = GetDlgItem(hDlg,IDC_COMBO_SERVER);
				for (int i=0;i < (sizeof(server)/sizeof(server[0]));i++) {
					::SendMessage(hWndCombo,CB_ADDSTRING,0L,(LPARAM)(LPCTSTR)server[i]);
					::SetWindowText(hWndCombo,server[i]);
					::SendMessage(hWndCombo,CB_SETCURSEL,(WPARAM)(int)i,0L);
				
				}
				hWnd = GetDlgItem(hDlg,IDC_EDIT_INFO);
				// Set text on the button
				if (g_sClient.m_hSocket) {
					HWND hWndButton = GetDlgItem(hDlg,IDC_BUTTON_SERVER);
					::SendMessage(hWndButton,WM_SETTEXT,0,(LPARAM)L"&Disconnect");
					::SetWindowText(hWnd,info[0]); 
				} else				
					::SetWindowText(hWnd,info[0]);
			
				::SetWindowText(hWndCombo,server[0]);
				::SendMessage(hWndCombo,CB_SETCURSEL,(WPARAM)(int)0,0L);

			}
			return TRUE;
		case WM_COMMAND:
			{
				DWORD dwID = LOWORD(wParam);
				// Close the dialog box
				if (dwID == IDC_BUTTON_CONNECT_CLOSE) {
					EndDialog(hDlg, LOWORD(wParam));
					return TRUE;
				}
				// Get notifications from the combo box
				if (dwID == IDC_COMBO_SERVER) {
					hWnd = GetDlgItem(hDlg,IDC_COMBO_SERVER);
					if(HIWORD(wParam) == CBN_SELENDOK)  {
						WCHAR szServerName[MAX_STRING], szPortNumber[MAX_STRING];
						WCHAR szComboText[MAX_STRING];
						DWORD dwSize = sizeof(szServerName);
						memset(szServerName,0,sizeof(szServerName));
						memset(szPortNumber,0,sizeof(szPortNumber));
						memset(szComboText,0,sizeof(szComboText));
						// Get port-number and sever-name from the combo
						// box and put this information into the edit boxes
						DWORD dwSel= ::SendMessage(hWnd,CB_GETCURSEL,(WPARAM)0,(LPARAM)0);
						::SendMessage(hWnd,CB_GETLBTEXT,(WPARAM)dwSel,(LPARAM)szComboText);
						PWCHAR szServName = wcsstr(szComboText,L" ");
						DWORD dwServerNameLength = szServName - szComboText + 1;	
						wcsncpy(szServerName,szComboText,dwServerNameLength - 1);
						wcscpy(szPortNumber,&szComboText[dwServerNameLength + 2]);
						HWND hWndServerName = GetDlgItem(hDlg,IDC_EDIT_SERVER_NAME);
						HWND hWndPortNumer = GetDlgItem(hDlg,IDC_EDIT_PORT_NUMBER);
						::SendMessage(hWndServerName,WM_SETTEXT,0,(LPARAM)(PWCHAR)szServerName);
						::SendMessage(hWndPortNumer,WM_SETTEXT,0,(LPARAM)(PWCHAR)szPortNumber);
					}
					return TRUE;
				}
				// Get notifications from the <connect> button
				if (dwID == IDC_BUTTON_SERVER) {
					// Try to connect to a socket server
					hWnd = GetDlgItem(hDlg,IDC_BUTTON_SERVER);
					if(HIWORD(wParam) == BN_CLICKED) {
						WCHAR szGetButtonText[MAX_STRING];
						WCHAR szServerName[MAX_STRING], szPortNumber[MAX_STRING];
						DWORD dwBytes = 0;
						CHAR request[] ="MMCLIENT IS STARTED\r\n";
						DWORD dwRequestLength = strlen(request);
						HWND hWndInfo = GetDlgItem(hDlg,IDC_EDIT_INFO);
						HWND hWndServerName = GetDlgItem(hDlg,IDC_EDIT_SERVER_NAME);
						HWND hWndPortNumber = GetDlgItem(hDlg,IDC_EDIT_PORT_NUMBER);
						::SendMessage(hWnd,WM_GETTEXT,MAX_STRING,(LPARAM)szGetButtonText);
						// Check if this program already is connected to a server
						if(!wcsicmp(szGetButtonText,L"Connect")) {
							// Get the port number and the server name from
							// the edit boxes
							::SendMessage(hWndServerName,WM_GETTEXT,MAX_STRING,(LPARAM)szServerName);
							wcstombs(g_strServerName,szServerName,MAX_STRING);
							::SendMessage(hWndPortNumber,WM_GETTEXT,MAX_STRING,(LPARAM)szPortNumber);
							wcstombs(g_strPortNumber,szPortNumber,MAX_STRING);

							// Check if there is any text inside the text boxes
							if((strlen(g_strPortNumber)) && (strlen(g_strServerName))) {
								// Try to create a socket
								g_sClient.Create();	
								g_saServer = CBlockingSocket::GetHostByName(g_strServerName,atoi(g_strPortNumber));	
								// Try to connect to the socket	
								if ( (g_sClient.Connect(g_saServer) != SOCKET_ERROR)) {
									// Try to write a socket start message to the server
									dwBytes = g_sClient.Write(request, dwRequestLength, 4);
									if (dwBytes == dwRequestLength) { // Success
										::SendMessage(hDlg,WM_COMMAND,(WPARAM)IDC_BUTTON_CONNECT_CLOSE,0L);
										ResumeThread(g_hThread); 
									} 
									else {
										// Can't write to the socket
										g_sClient.Close();

										::SendMessage(hWndInfo ,WM_SETTEXT,0L,(LPARAM)info[1]);
									}
								} 
								else {
									// Can't connect to the socket
									g_sClient.Close();
									::SendMessage(hWndInfo,WM_SETTEXT,0L,(LPARAM)info[2]);
								}
							}
							else {
								::MessageBox(hWnd,L"Write a server name\r\n and a port-number\r\n into the edit boxes,\r\n before you push\r\nthe connect button",NULL,MB_OK);
							}
						} else { // <disconnect> button => disconnect the socket 
							 // and suspend the socket thread
							SuspendThread(g_hThread); 
							g_sClient.Close();
							::SendMessage(hDlg,WM_COMMAND,(WPARAM)IDOK,0L);
						}
					}
					return TRUE;
				}
			break;
			}
	}
    return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTION: About
//
//  COMMENT:  Mesage handler for the About box.
/////////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32_WCE
	SHINITDLGINFO shidi;
#endif

	switch (message)
	{
		case WM_INITDIALOG:
#ifdef _WIN32_WCE 
			shidi.dwMask = SHIDIM_FLAGS;
			 shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
#endif
			return TRUE; 
		case WM_COMMAND:
			if (LOWORD(wParam) == IDC_BUTTON_ABOUT_CLOSE) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// FUNCTION: WriteHtmlDocument
//
// COMMENT: Write a html document to a file 
//
/////////////////////////////////////////////////////////////////////////////
DWORD WriteHtmlDocument(char * buffer)
{
	HANDLE hFile;
	DWORD dwBytesWrite;
	wchar_t wcError[MAX_STRING];
 
	if ((hFile = CreateFile(g_pszStandardFileName,       
						GENERIC_WRITE | GENERIC_READ,
						FILE_SHARE_READ | FILE_SHARE_WRITE,
						NULL,
						CREATE_ALWAYS,
						FILE_ATTRIBUTE_NORMAL,
						NULL)) == INVALID_HANDLE_VALUE) {
		LPVOID lpMsgBuf;
		FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error CreateFile(): %s\r\n",lpMsgBuf);
        MessageBox(hwndMain,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
	    return 0;
	}
	if (!WriteFile(hFile,buffer,strlen(buffer),&dwBytesWrite, NULL)) {
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			GetLastError(),
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
			); 
		swprintf(wcError,L"Error WriteFile(): %d\r\n",lpMsgBuf);
        MessageBox(hwndMain,wcError,NULL,MB_OK);
		LocalFree(lpMsgBuf);
		MessageBox(hwndMain,wcError,NULL,MB_OK);
		CloseHandle(hFile);
		return 0;
	}

	CloseHandle(hFile);

	return dwBytesWrite;
}

 
void Navigate(LPTSTR URL)
{	
	VARIANT vFlags = {0},
    vTargetFrameName = {0},
    vPostData = {0},
    vHeaders = {0};
	
	pBrowser->Navigate(URL, &vFlags,
          &vTargetFrameName, &vPostData, &vHeaders);	
}

/////////////////////////////////////////////////////////////////////////////
//  FUNCTIONS: CreateExitWindow, CreateBrowseWindow and CreateEditWindow
//
//  COMMENT:  Create button windows.
/////////////////////////////////////////////////////////////////////////////

HWND CreateExitWindow()
{
	DWORD dwStyle = WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON;

	return ::CreateWindow(
				TEXT("BUTTON"),
				TEXT("Exit"),
				dwStyle,
				0, 5 + dwToolbarHeight, 50, 30, 
				atlWnd,
				(HMENU)IDC_EXIT,
				hInst,
				NULL
				);
}

HWND CreateBrowseWindow()
{
	DWORD dwStyle = WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON;

	return ::CreateWindow(
				TEXT("BUTTON"),
				TEXT("GO"),
				dwStyle,
				205, 5 + dwToolbarHeight, 30, 30, 
				atlWnd,
				(HMENU)IDC_BROWSE,
				g_hInst,
				NULL
				);
}

HWND CreateEditWindow()
{
	DWORD dwStyle = /*WS_VISIBLE |*/ WS_CHILD | ES_MULTILINE | ES_READONLY | WS_VSCROLL;

	return ::CreateWindow(
				TEXT("EDIT"),
				TEXT("Edit"),
				dwStyle,
				5,5 + dwToolbarHeight,225,30,
				atlWnd,
				(HMENU)IDC_EDIT,
				g_hInst,
				NULL
				);
}

HWND CreateComboWindow()
{
	
	DWORD dwStyle = WS_VISIBLE | WS_CHILD | WS_VSCROLL | WS_VSCROLL | CBS_DROPDOWN | CBS_AUTOHSCROLL ;
	return ::CreateWindow(
				TEXT("COMBOBOX"),
				TEXT("COMBOBOX"),
				dwStyle,
				3,5 + dwToolbarHeight,200,100,
				atlWnd,
				(HMENU)IDC_COMBO,
				g_hInst,
				NULL
				);
}

