#include "events.h"
#include "webview.h"
// Microsoft IE 3.0 ActiveX interface for Pocket PC
IBrowser * pB = NULL;
int count = 0;

CMustClientEvents::CMustClientEvents(PVOID pTest)
{
    m_cRef = 1;
    m_hwndBrowser = ::FindWindow(TEXT("MUSTCLIENT"), TEXT("MustClient"));
	m_hwndEdit = NULL;
	//pB = (IBrowser *)pTest;
}

//IUnknown methods
STDMETHODIMP CMustClientEvents::QueryInterface(REFIID riid, void** ppv)
{
    if (riid == IID_IUnknown)
    {
        *ppv = static_cast<IUnknown*>(this);
    }
    else if (riid == IID_IDispatch)
    {
        *ppv = static_cast<IDispatch*>(this);
    }
    else
    {
        *ppv = NULL;
        return (E_NOINTERFACE);
    }
    reinterpret_cast<IUnknown*>(*ppv)->AddRef();
    return (S_OK);
}


STDMETHODIMP_(ULONG) CMustClientEvents::AddRef()
{
    return (::InterlockedIncrement(&m_cRef));
}


STDMETHODIMP_(ULONG) CMustClientEvents::Release()
{
    if (::InterlockedDecrement(&m_cRef) == 0)
    {
        delete this;
        return (0);
    }
    return (m_cRef);
}

//IDispatch Methods
STDMETHODIMP CMustClientEvents::GetTypeInfoCount(
		UINT* pctinfo
		)
{
	return (S_OK);
}

STDMETHODIMP CMustClientEvents::GetTypeInfo(
		UINT iTInfo,
		LCID lcid,
		ITypeInfo** ppTInfo
		)
{
	return (S_OK);
}

STDMETHODIMP CMustClientEvents::GetIDsOfNames(
		const IID& riid,
		LPOLESTR* rgszNames,
		UINT cNames,
		LCID lcid,
		DISPID* rgDispId
		)
{
	return (S_OK);
}

STDMETHODIMP CMustClientEvents::Invoke(
		DISPID dispIdMember,
		const IID& riid,
		LCID lcid,
		WORD dwFlags,
		DISPPARAMS* pDispParams,
		VARIANT* pVarResult,
		EXCEPINFO* pExcepInfo,
		UINT* puArgErr
		)
{
	HRESULT hr = S_OK;
	
	DISPPARAMS* pDisp=pDispParams;
	VARIANT* pVar = pVarResult;
	EXCEPINFO* pExcep = pExcepInfo;
	wchar_t wcEvent[256];
	wchar_t szBuf[100], szBufLast[100];;
	
	//pB->get_LocationURL(&szBuf[0]);



	
	
	switch(dispIdMember)
	{
	case BROWSER_EVENT_COMMAND_STATE_CHANGE:
		{
		wcscpy(wcEvent,L"Event\r\n");
		wcscat(wcEvent,(PWCHAR)pDispParams[0].rgvarg->bstrVal);
		::SendMessage(m_hwndBrowser,WM_COMMAND,(WPARAM)IDC_STOP_BROWSE,(LPARAM)(PWCHAR)wcEvent);
		}
		break;
	case BROWSER_EVENT_DOWNLOAD_BEGIN:
		{
		wcscpy(wcEvent,L"Event\r\n");
		wcscat(wcEvent,(PWCHAR)pDispParams[0].rgvarg->bstrVal);
		::SendMessage(m_hwndBrowser,WM_COMMAND,(WPARAM)IDC_STOP_BROWSE,(LPARAM)(PWCHAR)wcEvent);
		}
		break;
	case BROWSER_EVENT_DOWNLOAD_COMPLETE:
		break;
	case BROWSER_EVENT_FRAME_BEFORE_NAVIGATE:

		break;
	case BROWSER_EVENT_FRAME_NAVIGATE_COMPLETE:
		break;
	case BROWSER_EVENT_BEFORE_NAVIGATE:
		/*{
			BSTR buf[200];		
			//pB->Refresh();
		//	pB->get_LocationURL(&szBuf[0]);
			if (count >5) {
				pB->Stop();
			}
		count++;
		wcscpy(wcEvent,L"Event\r\n");
		wcscat(wcEvent,(PWCHAR)pDispParams[0].rgvarg->bstrVal);
		//::SendMessage(m_hwndBrowser,WM_COMMAND,(WPARAM)IDC_STOP_BROWSE,(LPARAM)(PWCHAR)wcEvent);
		}
		//m_Browser.pBrowser->Strop();*/
		break;

	case BROWSER_EVENT_NAVIGATE_COMPLETE:
		if (pDispParams->cArgs != 1)
		{
			hr = ResultFromScode(DISP_E_BADPARAMCOUNT);
			break;
		}	
		if (pDispParams[0].rgvarg->vt != VT_BSTR)
		{
			//We have an error
			hr = ResultFromScode(E_INVALIDARG);
			break;

		} else {

			// BSTR buf[200];
			if(count > 6) {
				pB->Stop();
				if (wcscmp((const wchar_t *)szBuf,(const wchar_t *)szBufLast)) {
				//	pB->Navigate(*szBuf, 0, NULL, NULL);
					wcscpy((wchar_t *)szBufLast,(const wchar_t *)szBuf);
				}
			}
			//pB->get_LocationURL(&buf[0]);
			wchar_t wcEvent[256];
			wcscpy(wcEvent,L"Event\r\n");
			wcscat(wcEvent,(PWCHAR)pDispParams[0].rgvarg->bstrVal);
			//::SendMessage(m_hwndBrowser,WM_COMMAND,(WPARAM)IDC_STOP_BROWSE,(LPARAM)(PWCHAR)wcEvent);
			// Send event to main window
			::SendMessage(m_hwndBrowser,WM_COMMAND,(WPARAM)IDC_SEND_TO_SOCKET,(LPARAM)(PWCHAR)wcEvent);
			// Send event to debug window
			SetWindowText(m_hwndEdit,(PWCHAR)wcEvent);
		}
		break;

	default:
		break;
	}
	return (hr);
}
