#ifndef __SOCKET_STR__
#define __SOCKET_STR__

#include "winsock.h"
#include "string.h"
#include "stdio.h"


class socket_stream
{
private:
  SOCKADDR_IN m_hSockaddr;
  SOCKET      m_hSocket;
  //PHOSTENT phostent = NULL;           // Points to the HOSTENT structure of the server
  WSADATA m_hWSAData;
  
  SOCKADDR_IN *GetHostByAddr(char *ipaddr, const USHORT ushPort);
  SOCKADDR_IN *GetHostByName(const char* pchName, const USHORT ushPort = 0);
  u_long ToIPAdr(char *hname); 
  int display_error(); 

TCHAR szError[100]; 

public:
	socket_stream(char *ip_address,int port); 
	~socket_stream(); //
	int read(char *buf, int buf_size,int wait, void *info); //returns the no.of bytes read
	int read(char *buf, int buf_size, int wait);
    int write(char *buf, int buf_size); //Returns the no.of bytes written
	int connectToServer(char *ip_address,int port);
	int resetConnection();
	int close(); //Success >0

};

#endif