#ifndef __VOIP_H
#define __VOIP_H

#include  "sync.h" 
#include "wavply.h"
#include "wavrec.h"

class VoIP
{
private:
	socket_stream *ss;
	WavPly  *wpobj;
	WavRec  *wrobj;
	HWND m_hwnd;
	Sync *sobj;
	int verbosed;
	FILE * VoipLog;
	int mic_off;


public:
    VoIP(HWND);
	~VoIP();
	int Start(char *ip, int port);
	int Stop();
	void setVerbosity(int v);
	void set_micOff();
	void set_micOn();

};


#endif